// u[N֌W̊֐
//
// Copyright (c) 2001-2003 Tomoya Tokairin


#include "dbg.h"


#define MAX_BREAKPOINT	65536	// u[N|Cg̍ő吔

// u[N|Cgłꏊ̃AhXƂ
// IWĩR[hƂۑĂf[^x[X
typedef struct{
	DWORD dwAddr;					// AhX
	BYTE org_code[MAX_ORG_CODE];	// IWĩR[h
	DWORD org_codelen;				// ۑĂR[h̒
	DWORD dwNextIndex;				// ̃CfbNX
	char szComment[CHR_BUF];		// Rg(֐Ƃ)
	char szComment2[CHR_BUF];		// Rg(֐Ƃ)
	char szModule[CHR_BUF];			// W[
	DWORD dwHitCount;				// qbg
	DWORD dwObservNum;				// ڂ break Ďn߂邩
}BREAKINFO,*LPBREAKINFO;


LPBREAKINFO LpBreakInfo[MAX_BREAKPOINT];
DWORD DwBreakNum = 0;
DWORD DwTopIndex = 0;

//------------------------------------------------------------

//--------------------------------
// f[^x[X̃\[g & T[`֐
// qbg񐔂̍AhXɗ悤ɂB
//
// ߂l: w肵AhX̃f[^x[X̃CfbNX (s -1)
//
DWORD SortBreakIndex(DWORD dwAddr){

	DWORD i;
	DWORD dwPrevIndex = -1;
	DWORD dwIndex = DwTopIndex;

	for(i=0; i< DwBreakNum ;i++){

		if(LpBreakInfo[dwIndex]->dwAddr == dwAddr){

			// ɃgbvȂ炻̂܂ܖ߂
			if(dwPrevIndex == -1) return dwIndex;
			
			// gbvֈړ
			LpBreakInfo[dwPrevIndex]->dwNextIndex = LpBreakInfo[dwIndex]->dwNextIndex;
			LpBreakInfo[dwIndex]->dwNextIndex = DwTopIndex;
			DwTopIndex = dwIndex;
			return dwIndex;
		}

		dwPrevIndex = dwIndex;
		dwIndex = LpBreakInfo[dwIndex]->dwNextIndex;
	}

	return -1;
}


//-----------------------------------
// qbgJE^[グ֐
DWORD CountUpAddr(DWORD dwAddr,LPDWORD lpdwObservNum){

	DWORD i;

	i = SortBreakIndex(dwAddr);
	if(i == -1) return -1;
	LpBreakInfo[i]->dwHitCount++;

	if(lpdwObservNum) *lpdwObservNum = LpBreakInfo[i]->dwObservNum; 
	return LpBreakInfo[i]->dwHitCount;
}



//-----------------------------------
// w肵AhX̃IWĩR[hۑ֐
BOOL SaveOrgCode(HANDLE hProcess,DWORD dwAddr,DWORD dwLeng,
				 LPSTR lpszComment,LPSTR lpszComment2,DWORD dwObservNum)
{
	DWORD i,dwByte;

	if(dwLeng > MAX_ORG_CODE) return FALSE;

	// ɕۑĂ邩ǂ
	i = SortBreakIndex(dwAddr);

	if(i == -1)
	{ // ̈m
		i = DwBreakNum;
		if(DwBreakNum == MAX_BREAKPOINT) return FALSE;
		LpBreakInfo[i] = (LPBREAKINFO)malloc(sizeof(BREAKINFO) + 16);
		memset(LpBreakInfo[i],0,sizeof(BREAKINFO));
		LpBreakInfo[i]->dwNextIndex = DwTopIndex;

		DwTopIndex = DwBreakNum;
		DwBreakNum++;
	}
	else
	{ // ɕۑĂ
		if(LpBreakInfo[i]->org_codelen >= dwLeng) return TRUE; 
	}


	// R[hۑ
	LpBreakInfo[i]->dwAddr = dwAddr;
	if(!ReadProcessMemory(hProcess,(LPVOID)dwAddr,(LPVOID)LpBreakInfo[i]->org_code,dwLeng,&dwByte)) return FALSE;
	if(dwByte != dwLeng) return FALSE;
	LpBreakInfo[i]->org_codelen = dwLeng;
	if(lpszComment)	strcpy(LpBreakInfo[i]->szComment,lpszComment);
	if(lpszComment2) strcpy(LpBreakInfo[i]->szComment2,lpszComment2);
	GetModuleNameByAddr(dwAddr,LpBreakInfo[i]->szModule);
	LpBreakInfo[i]->dwObservNum = dwObservNum;

	return TRUE;
}


//-----------------------------------
// w肵AhX̃IWĩR[h񕜂֐
// SaveOrgCode() ŃR[hۑĂKvB
BOOL RestoreOrgCode(HANDLE hProcess,DWORD dwAddr,DWORD dwLeng){

	DWORD i,dwByte;
	BYTE code[MAX_ORG_CODE];

	i = SortBreakIndex(dwAddr);

	if(i == -1)
	{
		OutputErrorMessage("SortBreakIndex : failed in RestoreOrgCode\n");
		return FALSE;
	}
	if(LpBreakInfo[i]->org_codelen < dwLeng) return FALSE;
	memcpy(code,LpBreakInfo[i]->org_code,dwLeng);

	if(!WriteProcessMemory(hProcess,(LPVOID)dwAddr,(LPVOID)code,dwLeng,&dwByte)) return FALSE;
	FlushInstructionCache(hProcess,(LPVOID)dwAddr,dwLeng);

	return TRUE;
}



//--------------------------------
// qbgu[N|Cg̏S\֐
BOOL ShowTotalBreakInfo(){
	DWORD i;
	
	OutputErrorMessage("number of break points: %d\n\n",DwBreakNum);
	
	for(i = 0; i< DwBreakNum; i++) {
		if(LpBreakInfo[i]->dwHitCount)
			OutputErrorMessage("0x%08x %s| %s : %s  x %d\n",
			LpBreakInfo[i]->dwAddr,
			LpBreakInfo[i]->szModule,
			LpBreakInfo[i]->szComment,
			LpBreakInfo[i]->szComment2,
			LpBreakInfo[i]->dwHitCount);
	}
	
	return TRUE;
}


//--------------------------------
// u[N|Cg̏NA֐
BOOL ClearBreakInfo(){
	DWORD i;

	for(i = 0; i< DwBreakNum; i++) free(LpBreakInfo[i]);
	DwBreakNum = 0;
	
	return TRUE;
}


//------------------------------------------------
// w肵AhX break łފ֐(R[h͕ۑȂ)
BOOL EmbedBreak(HANDLE hProcess,DWORD dwAddr){

	BYTE bBreak = 0xcc; // int 3
	DWORD dwByte;

	if(!WriteProcessMemory(hProcess,(LPVOID)dwAddr,(LPVOID)&bBreak,1,&dwByte)) return FALSE;
	FlushInstructionCache(hProcess,(LPVOID)dwAddr,1);

	return TRUE;
}


//------------------------------------
// w肵AhX break łފ֐(R[hۑ)
//  RestoreBreakPoint() ƑgŎgpB
BOOL PushBreakatSpecifiedAddr(HANDLE hProcess,
							DWORD dwAddr,
							DWORD dwOrgCodeLen,
							LPSTR lpszComment,
							LPSTR lpszComment2,
							DWORD dwObservNum
							
							)
{
	// IWĩR[hۑ
	if(!SaveOrgCode(hProcess,dwAddr,dwOrgCodeLen,lpszComment,lpszComment2,dwObservNum))
	{
		OutputErrorMessage("SaveOrgCode : failed in nPushBreakatSpecifiedAddr at 0x%x\n",dwAddr);
		return FALSE;
	}

	// break ł
	if(!EmbedBreak(hProcess,dwAddr))
	{
		OutputErrorMessage("EmbedBreak : failed in nPushBreakatSpecifiedAddr at %x\n",dwAddr);
		return FALSE;
	}

	return TRUE;
}




//------------------------------------
// u[ŇAIWĩR[h񕜂֐B
//   PushBreakatSpecifiedAddr() sɎgB
// 
// xu[NłꍇÅ֐Ă񂾌͂ł
// R[h͕ۑĂƉ肳̂ŉ ExecStep() ŃXebvs
//  EmbedBreak(*lpdwBreakAddr) ĂԂł悢B
//
//  PushBreakatSpecifiedAddr()-> u[N -> RestoreBreakPoint() 
//    -> ExecStep() -> Xebvs ->  EmbedBreak(*lpdwBreakAddr) Ċ
//
// ̂܂܃u[N|Cg폜ꍇ ExecStep() ͌ĂԕKvȂB
//
BOOL RestoreBreakPoint(HANDLE hProcess,
					  HANDLE hThread,
					  DWORD dwEIP, // Zbg EIP (0 Ȃ炻̂܂)
					  LPDWORD lpdwBreakAddr,  // break point łĂAhXԂ
					  DWORD dwOrgCodeLen
					  ){

	CONTEXT context;

	// eip Zbg
	context.ContextFlags = CONTEXT_FULL;
	if(!GetThreadContext(hThread,&context)){
		OutputErrorMessage("GetThreadContext : failed\n");
		return FALSE;
	}
	
	if(dwEIP){
		context.Eip = dwEIP;
		if(!SetThreadContext(hThread,&context)){
			OutputErrorMessage("SetThreadContext : failed\n");
			return FALSE;
		}
	}
	else dwEIP = context.Eip;

	// IWiR[h
	if(!RestoreOrgCode(hProcess,dwEIP,dwOrgCodeLen))
	{
		OutputErrorMessage("RestoreOrgCode : failed in  RestoreBreakPoint at 0x%x\n",dwEIP);
		return FALSE;
	}

	*lpdwBreakAddr = dwEIP;

	return TRUE;
}



//------------------------------------
//XebvsZbg֐
BOOL ExecStep(HANDLE hProcess,
					  HANDLE hThread					  
					  ){

	CONTEXT context;

	// TF rbg𗧂Ă
	context.ContextFlags = CONTEXT_FULL;
	if(!GetThreadContext(hThread,&context)){
		OutputErrorMessage("GetThreadContext : failed\n");
		return FALSE;
	}

	context.EFlags |= 0x100;  // TF rbg(= 8 bit) Zbg

	if(!SetThreadContext(hThread,&context)){
		OutputErrorMessage("SetThreadContext : failed\n");
		return FALSE;
	}

	return TRUE;
}



//------------------------------------
//Xebvs֐
BOOL ExecUnStep(HANDLE hProcess,
					  HANDLE hThread
					  
					  ){

	CONTEXT context;

	context.ContextFlags = CONTEXT_FULL;
	if(!GetThreadContext(hThread,&context)){
		OutputErrorMessage("GetThreadContext : failed\n");
		return FALSE;
	}

	context.EFlags &= ~0x100;  // TF rbg(= 8 bit) 

	if(!SetThreadContext(hThread,&context)){
		OutputErrorMessage("SetThreadContext : failed\n");
		return FALSE;
	}

	return TRUE;
}



//------------------------------------
// IWi̊֐sɂ̂܂ ret ֐
BOOL ReturnAPI(HANDLE hProcess,HANDLE hThread,
			   WORD wCrearStackSize,   // NAX^bNTCY
			   BOOL bSetBreak,  // break Zbgꍇ
			   DWORD dwEAX  // ߂l(eax ̒l) 
			   ){

	DWORD eip;
	DWORD i;
	DWORD dwByte;
	BYTE code[5];
	DWORD dwCodeLen;
	CONTEXT context;

	context.ContextFlags = CONTEXT_FULL;
	if(!GetThreadContext(hThread,&context)){
		OutputErrorMessage("GetThreadContext : failed\n");
		return FALSE;
	}
	eip = context.Eip;

	if(bSetBreak) i=1;else i=0;
	if(wCrearStackSize){ 	
		dwCodeLen = 3+i;
		code[0] = 0xcc; // int 3
		code[i] = 0xc2; // ret wCrearStackSize
		memcpy(code+i+1,&wCrearStackSize,sizeof(WORD));
	}
	else{ 
		dwCodeLen = 1+i;
		code[0] = 0xcc; // int 3
		code[i] = 0xc3;	//ret 0
	}

	if(!WriteProcessMemory(hProcess,(LPVOID)eip,(LPVOID)code,dwCodeLen,&dwByte)){
		OutputErrorMessage("WriteProcessMemory : failed in ReturnAPI()\n");
		return FALSE;
	}
	FlushInstructionCache(hProcess,(LPVOID)eip,dwCodeLen);
	
	if(bSetBreak) context.Eip++;
	context.Eax = dwEAX;
	if(!SetThreadContext(hThread,&context)){
		OutputErrorMessage("SetThreadContext : failed\n");
		return FALSE;
	}

	return TRUE;
}



//------------------------------------------
// w肵AhXɂu[N|Cg𖳌ɂ֐
BOOL CancelBreakPoint(HANDLE hProcess,HANDLE hThread,DWORD dwAddr){

	DWORD i;

	i = SortBreakIndex(dwAddr);
	if(i == -1) return FALSE;

	LpBreakInfo[i]->dwObservNum = 0;

	return ExecUnStep(hProcess,hThread);
}



//------------------------------------------
// ݒt@CɏĂAhXɃu[N|Cgł֐
// ݒt@C
//
// AhX(16i)  W[  Rg1 Rg2
//
// Ƃ`
BOOL ReadBreakSettingFile(HANDLE hProcess,LPSTR lpszBreakFile,BOOL bDebug){
	
	FILE* fBreak;
	DWORD dwAddr;
	char szTemp[CHR_BUF],*lpszTemp;
	char szComment1[CHR_BUF];
	char szComment2[CHR_BUF];
	DWORD dwObservNum,i;

	
	if(!lpszBreakFile) return FALSE;
	
	if(bDebug) OutputErrorMessage("\n[Read %s to set break point]\n\n",lpszBreakFile);
	
	if(!(fBreak = fopen(lpszBreakFile,"r"))){
		OutputErrorMessage("Can't open %s\n",lpszBreakFile);
		return FALSE;
	}
	
	for(;;){
		
		lpszTemp = szTemp;
		fgets(szTemp,CHR_BUF,fBreak);
		if(feof(fBreak)) break;
		
		i=0; while(*lpszTemp == ' ' || *lpszTemp == '\r' || *lpszTemp == '\n') lpszTemp++;
		if(strlen(lpszTemp) && lpszTemp[0] != '#')
		{ 
			dwObservNum = 1;
			memset(szComment1,0,CHR_BUF);
			memset(szComment2,0,CHR_BUF);
			sscanf(lpszTemp,"%x %d %s %s",&dwAddr,&dwObservNum,szComment1,szComment2);
			
			if(bDebug) OutputErrorMessage("0x%x %d %s %s\n",dwAddr,dwObservNum,szComment1,szComment2);

			// ɕۑĂ邩ǂ
			i = SortBreakIndex(dwAddr);
			
			if(i == -1)
			{
				if(!PushBreakatSpecifiedAddr(hProcess,dwAddr,
					MAX_ORG_CODE,szComment1,szComment2,dwObservNum))
				{
					fclose(fBreak);
					return FALSE;
				}
			}
			else
			{
				if(bDebug) OutputErrorMessage("[This address had already been saved]\n\n");
			}
		}
	}
	
	fclose(fBreak);
	return TRUE;
}




//------------------------------------------
// ݒt@CɃu[N|Cgۑ֐
// ݒt@C
//
// AhX(16i)  W[  Rg1 Rg2
//
// Ƃ`
BOOL SaveBreakSettingFile(LPSTR lpszBreakFile,BOOL bDebug){
	
	DWORD i;
	FILE* fBreak;
	char szTemp[CHR_BUF];

	if(!lpszBreakFile) return FALSE;
	
	if(bDebug) OutputErrorMessage("\n[Save break points to %s]\n\n",lpszBreakFile);
	
	if(!(fBreak = fopen(lpszBreakFile,"w"))){
		OutputErrorMessage("Can't open %s\n");
		return FALSE;
	}
	
	for(i = 0; i< DwBreakNum; i++) {

		sprintf(szTemp,"0x%x  %d  %s  %s\n",
			LpBreakInfo[i]->dwAddr,LpBreakInfo[i]->dwObservNum,
			LpBreakInfo[i]->szComment,LpBreakInfo[i]->szComment2);

		fputs(szTemp,fBreak);

	}
	
	fclose(fBreak);
	return TRUE;
}



//-----------------------------------------------------------------
// ݂̃AhXɐݒ肳Ău[N|Cg̃e[u𒲂ׂāA\֐
void ShowBreakInfo(DWORD dwAddr,HANDLE hThread){

	OutputErrorMessage("addr: 0x%08x  thread: 0x%08x\n",dwAddr,(DWORD)hThread);
	
	if(SortBreakIndex(dwAddr) != -1){
		OutputErrorMessage("count: %d\ncomment1: %s\ncomment2: %s\nmodule: %s",
			LpBreakInfo[DwTopIndex]->dwHitCount,
			LpBreakInfo[DwTopIndex]->szComment,
			LpBreakInfo[DwTopIndex]->szComment2,
			LpBreakInfo[DwTopIndex]->szModule);
	}

	OutputErrorMessage("\n");

}

//EOF