#ifndef MYIO_H
#define MYIO_H


#define LOCATE_CALLSTACK_X	40
#define LOCATE_REG_X		75

#define LOCATE_INFO_HT		5		// EBhE
#define LOCATE_MEM_HT		9		// EBhE
#define LOCATE_CODE_HT		14		// R[hEBhE
#define LOCATE_VARWATCH_HT	10		// ϐEHb`EBhE

#define MEM_DUMPSIZE		256

#define DIAG_SHOWINFO		1
#define DIAG_SHOWCALLSTACK	2
#define DIAG_SHOWSTACK		4
#define DIAG_SHOWSTACK2		8
#define DIAG_SHOWMEM		16
#define DIAG_SHOWCODE		64
#define DIAG_SHOWREG		128
#define DIAG_SHOWVARWATCH	256

BOOL Event_CreateFile(HANDLE hProcess,HANDLE hThread,LPTHREADINFO lpThInfo,BOOL bWide,BOOL bMMIO,DWORD dwDebugLevel);
BOOL Event_CreateFile2(HANDLE hProcess,HANDLE hThread,LPTHREADINFO lpThInfo,LPFILETABLE lpFileTable,LPBUFFINFO lpBufferInfo,DWORD dwDebugLevel);
BOOL Event_CloseHandle(HANDLE hProcess,HANDLE hThread,LPTHREADINFO lpThInfo,LPFILETABLE lpFileTable,DWORD dwDebugLevel);
BOOL Event_SetFilePointer(HANDLE hProcess,HANDLE hThread,LPTHREADINFO lpThInfo,LPFILETABLE lpFileTable,LPBUFFINFO lpBufferInfo,BOOL bMMIO,DWORD dwDebugLevel);
BOOL Event_ReadFile(HANDLE hProcess,HANDLE hThread,LPTHREADINFO lpThInfo,LPFILETABLE lpFileTable,LPBUFFINFO lpBufferInfo,BOOL bVerbose,BOOL bMMIO,DWORD dwDebugLevel);
BOOL ShowInformation(HANDLE hProcess,HANDLE hThread,LPTHREADINFO lpThInfo,DWORD dwEIP,DWORD dwESP,DWORD dwDump,char szOperand[][CHR_BUF],DWORD dwShowWindow);
BOOL DialogMode(HANDLE hProcess,HANDLE hThread,LPTHREADINFO lpThInfo,DWORD dwEIP,DWORD dwESP,char szOperand[][CHR_BUF],LPDIAGDATA lpdiagData,LPBOOL lpStepMode);
DWORD ReadFromStdin(LPBYTE lpBuf,DWORD dwReadByte,BOOL bDebug);
BOOL LoadDllEvent(HANDLE hProcess,DWORD dwImageBase,DWORD dwDebugLevel);
DWORD WriteDataToChildProcess(HANDLE hProccess, 
							 HANDLE hThread,
							 LPBUFFINFO lpBuffer,
							 LPTHREADINFO lpThInfo,
							 DWORD dwTargetNum,
							 BOOL bVerbose,
							 BOOL bDebug
							 );
void ReadDataFromStdin(LPBUFFINFO lpBuffer,
					   DWORD dwLeng,  // ǂݍݗ
					   DWORD dwTarget,
					   BOOL bDebug
					   );
BOOL Event_GetFileSize(HANDLE hProcess,
					   HANDLE hThread,
					   LPTHREADINFO lpThInfo,
					   LPFILETABLE lpFileTable,
					   LPBUFFINFO lpBufferInfo,
					   BOOL bMMIO,
					   DWORD dwDebugLevel
					   );
BOOL FeofStdin();
#endif