//  u FSTDIN v 
//  Copyright (c) 2001-2003 Tomoya Tokairin

#include "main.h"

int main(int argc,char* argv[])
{
	
	char szCommand[MAX_COMMANDLEN];
	char szOutputFile[MAX_PATH];
	char szErrFile[MAX_PATH];
	char szTemp[CHR_BUF];
	BOOL bCommand = TRUE;
	DWORD i,i2;
	DWORD dwRet = 1; // ߂l
	
	// qvZX̃nh
	HANDLE hProcess;
	
	szErrFile[0]='\0';
	szTemp[0]='\0';

	// Xbh
	THREADINFO thInfo[MAX_THREAD];
	memset(&thInfo,0,sizeof(THREADINFO)*MAX_THREAD);
	
	// t@Ce[u
	FILETABLE fTable;
	memset(&fTable,0,sizeof(fTable));
	for(i=0;i<MAX_READFILE;i++)	fTable.dwTargetStream[i] = MAX_OPENHANDLE-1;
	strcpy(fTable.szTargetFile,"dummy.dat");
	
	// Xbhe[u
	THREADTABLE thTable;
	memset(&thTable,0,sizeof(thTable));
	
	// obt@
	BUFFINFO buffer;
	memset(&buffer,0,sizeof(BUFFINFO));
	buffer.dwBufSize = 1;
	
	// API ̃AhX
	DWORD dwAPIaddr[NUMOFREPLACEAPI];

	// MSCVRT ̂ݒT
	BOOL bSearchOnlyMSVCRT = FALSE;
	
	// ̑ݒ
	DWORD dwOffset = 0;
	BOOL bHideWindow = FALSE;
	BOOL bVerbose = FALSE;
	BOOL bShowImport = FALSE;
	BOOL bShowExport = FALSE;
	DWORD dwDebugLevel = 0;
	char szBreakFile[MAX_PATH];
	szBreakFile[0] = '\0';
	DWORD dwGetDefApiAddr = GETDEFAPIADDR_NO;
	DWORD dwMakeDummyFromData = FALSE;
	BOOL bNewConsole = FALSE;
	BOOL bHideConsole = FALSE;
	
	BOOL bOutWaveFormat = FALSE;
	WAVEFORMATEX waveFmt;

	// I wave t@C̎TCYƃwb_킹
	BOOL bAdjustWaveSize = FALSE;
	char szAdjustWaveSize[MAX_PATH];
	
	fprintf(stderr,TITLE);
	
	if(argc == 1)
	{
		fprintf(stderr,"\nfstdin [option] command ...\n\n");
		
		fprintf(stderr,"[option]\n");
		fprintf(stderr,"-dbg / -dbgfile / -dialog / -import / -export / -breakfile  \n");
		fprintf(stderr,"-stdin / -defaultaddr / -dos / -mmio\n");
		fprintf(stderr,"-buf / -file / -start / -offset / -v / -command / -hide /  -wavefmt  / -mkdmy / -dmysize / -adjwave\n");
		fprintf(stderr,"-newcon / -hidecon\n");
		exit(0);
	}
	
	// IvV擾
	argc--;
	argv++;
	memset(szCommand,0,MAX_COMMANDLEN);
	memset(szOutputFile,0,MAX_COMMANDLEN);
	while(argc){
		//----------------
		// W͗p[hݒ
		//----------------

		// -dos
		if(!strcmp(*argv,"-dos")) 
		{
			// NT J[l̎ -stdin ɂ
			OSVERSIONINFO osinfo;
			osinfo.dwOSVersionInfoSize = sizeof(OSVERSIONINFO);
			GetVersionEx(&osinfo);
			if(osinfo.dwPlatformId == VER_PLATFORM_WIN32_WINDOWS)
				dwGetDefApiAddr = GETDEFAPIADDR_BYIMPORT;
			else dwGetDefApiAddr = GETDEFAPIADDR_BYEXPORT;
		}
		// -stdin
		else if(!strcmp(*argv,"-stdin")) dwGetDefApiAddr = GETDEFAPIADDR_BYEXPORT;
		// -defaultaddr
		else if(!strcmp(*argv,"-defaultaddr")) dwGetDefApiAddr = GETDEFAPIADDR_DEFAULT;
		// -mmio
		else if(!strcmp(*argv,"-mmio")) dwGetDefApiAddr = GETDEFAPIADDR_MMIO;
		// -coff (݊̂ߎcĂ邾)
		else if(!strcmp(*argv,"-coff")) dwGetDefApiAddr = GETDEFAPIADDR_BYIMPORT;
		// -nostdin(݊̂߂̂Ă邾)
		else if(!strcmp(*argv,"-nostdin")) dwGetDefApiAddr = GETDEFAPIADDR_NO;
		// -mkdmy
		else if(!strcmp(*argv,"-mkdmy")){
			dwMakeDummyFromData = atoi(*(++argv));
			argc--;
		}
		// -buf
		else if(!strcmp(*argv,"-buf")){
			buffer.dwBufSize = atoi(*(++argv));
			argc--;
			
			// 2^x ɂ킹
			while((buffer.dwBufSize & (buffer.dwBufSize-1))) buffer.dwBufSize--;
			
		}
		// -file
		else if(!strcmp(*argv,"-file")){
			strcpy(fTable.szTargetFile,*(++argv));
			argc--;
		}
		// -offset
		else if(!strcmp(*argv,"-offset"))
		{
			dwOffset = atoi(*(++argv));
			argc--;
		}
		// -start
		else if(!strcmp(*argv,"-start"))
		{
			buffer.dwStart = atoi(*(++argv))-1;
			argc--;
		}
		// -dmysize
		else if(!strcmp(*argv,"-dmysize"))
		{
			thInfo[0].liFileSize.QuadPart = _atoi64(*(++argv));
			argc--;
			for(i=1;i<MAX_THREAD;i++)
				thInfo[i].liFileSize.QuadPart = thInfo[0].liFileSize.QuadPart;
		}
		// -v
		else if(!strcmp(*argv,"-v")) bVerbose = TRUE;
		// -newcon
		else if(!strcmp(*argv,"-newcon")) bNewConsole = TRUE;
		// -hidecon
		else if(!strcmp(*argv,"-hidecon")) 
		{
			bHideConsole = TRUE;
			bNewConsole = TRUE;
		}
		// -wavefmt
		else if(!strcmp(*argv,"-wavefmt")){
			waveFmt.wBitsPerSample = atoi(*(++argv));
			waveFmt.nChannels = atoi(*(++argv));
			waveFmt.nSamplesPerSec = atoi(*(++argv));
			argc-=3;
			SetWaveFmt(&waveFmt,waveFmt.nChannels,waveFmt.nSamplesPerSec,waveFmt.wBitsPerSample);
			bOutWaveFormat = TRUE;
		}
		// -adjwave
		else if(!strcmp(*argv,"-adjwave")){
			bAdjustWaveSize = TRUE;
			strcpy(szAdjustWaveSize,*(++argv));
			argc--;
		}
		// -hide
		else if(!strcmp(*argv,"-hide")) bHideWindow = TRUE;
		// -command
		else if(!strcmp(*argv,"-command")){
			strcpy(szCommand,*(++argv));
			argc--;
			bCommand = FALSE;
		}
		// -msvcrt
		else if(!strcmp(*argv,"-msvcrt")) bSearchOnlyMSVCRT = TRUE;

		//--------------------------
		// fobO[hpR}h
		//--------------------------

		// -breakfile
		else if(!strcmp(*argv,"-breakfile")){
			strcpy(szBreakFile,*(++argv));
			argc--;
		}
		// -dialog
		else if(!strcmp(*argv,"-dialog")) {
			dwDebugLevel = 1;
			SetOutputMode(ERRMODE_DIALOG,NULL);
		}
		// -dbgfile
		else if(!strcmp(*argv,"-dbgfile")){
			strcpy(szErrFile,*(++argv));
			argc--;
			if(!SetOutputMode(ERRMODE_FILE,szErrFile)){
				fprintf(stderr,"Can't Open %s\n",szErrFile);
				exit(1);
			}
		}
		// -import
		else if(!strcmp(*argv,"-import")) bShowImport = TRUE;
		// -export
		else if(!strcmp(*argv,"-export")) bShowExport = TRUE;
		// -dbglevel(݊̂߂̂Ă邾)
		else if(!strcmp(*argv,"-dbg")){
			dwDebugLevel = atoi(*(++argv)) + 1;
			argc--;
		}
		else{

			//------------------
			// R}h
			//------------------
			if(bCommand){
				if(!strlen(szCommand)) strcpy(szCommand,*argv);
				else wsprintf(szCommand,"%s %s",szCommand,*argv);
			}
			else 
				//------------------
				// o̓t@C
				//------------------
			{
				strcpy(szOutputFile,*argv);
			}
		}
		argv++; argc--;
	}
	if(!bCommand) SetCommandStrings(TRUE,szCommand,szCommand,szOutputFile);
	
	if(strlen(szErrFile)) OutputErrorMessage("-dbgfile %s\n",szErrFile);

	if(GetCurrentOutputMode() == ERRMODE_DIALOG && strlen(szBreakFile)==0) strcpy(szBreakFile,"breakpoint.txt");

	if(strlen(szBreakFile)) OutputErrorMessage("-breakfile %s\n",szBreakFile);
	
	OutputErrorMessage("buffer size: %d M\n",buffer.dwBufSize);
	OutputErrorMessage("debug level: %d\n",dwDebugLevel-1);
	OutputErrorMessage("target: %s\n",fTable.szTargetFile);
	OutputErrorMessage("start point: %d\n",buffer.dwStart+1);
	OutputErrorMessage("offset: %d byte\n",dwOffset);
	OutputErrorMessage("file size = %lu byte (high = %lu)\n",
		thInfo[0].liFileSize.LowPart,thInfo[0].liFileSize.HighPart);
	if(bNewConsole) 
	{
		OutputErrorMessage("console: new");
		if(bHideConsole) OutputErrorMessage(",hide");
		OutputErrorMessage("\n");
	}
	if(bOutWaveFormat) OutputErrorMessage("output waveformat %d bit,%d chn, %d hz\n",
		waveFmt.wBitsPerSample,waveFmt.nChannels,waveFmt.nSamplesPerSec);

	OutputErrorMessage("command: %s\n",szCommand);
	
	//---------------------------------------
	//---------------------------------------
	//---------------------------------------

	DWORD dwEventNum,dwHitCount,dwObservNum;
	DWORD dwEIP,dwESP;
	DWORD dwCurThreadNum;
	HANDLE hCurThread;
	LPTHREADINFO lpCurThInfo;
	DEBUG_EVENT debugEvent;
	DWORD dwShowWindow;
	char szOperand[4][CHR_BUF];
	BOOL bStepMode = FALSE;
	DWORD dwContinueStatus;
	DWORD dwReportRet;


	// _CAO[hpݒ
	DIAGDATA diagData;
	if(GetCurrentOutputMode() == ERRMODE_DIALOG){
		dwDebugLevel = 1;
		ReadSettingFile(&diagData);
	}
	

	// qvZXN
	EXECDATA execData;
	execData.lpszCommand = szCommand;
	execData.dwAPIaddr = dwAPIaddr;
	execData.bHideWindow = bHideWindow;
	execData.bShowImport = bShowImport;
	execData.bShowExport = bShowExport;
	execData.bDialog = (GetCurrentOutputMode() == ERRMODE_DIALOG);
	execData.dwDebugLevel = dwDebugLevel;
	execData.lpszBreakFile = szBreakFile;
	execData.dwGetDefApiAddr = dwGetDefApiAddr;
	execData.bSearchOnlyMSVCRT = bSearchOnlyMSVCRT;
	execData.bNewConsole = bNewConsole;
	execData.bHideConsole = bHideConsole;
	if(!ExecTergetProcess(&execData)) goto L_ERROR;
	hProcess = execData.proInfo.hProcess;
	
	if(bShowImport || bShowExport){
		TerminateProcess(hProcess,1);
		Sleep(100);
		exit(0);
	}
	
	thTable.dwThreadID[0] = execData.proInfo.dwThreadId;
	thTable.hThread[0] = execData.proInfo.hThread;
	thTable.dwThreadNum++;
	
	if(dwDebugLevel){
		OutputErrorMessage("\nmain thread ID = 0x%x\n",thTable.dwThreadID[0]);
		OutputErrorMessage("main thread handle = 0x%x\n",thTable.hThread[0]);
	}
	
	//-----------------------------------------
	
	// obt@쐬
	buffer.dwBufSize *= 1024 * 1024;
	buffer.lpBuffer = (LPBYTE)malloc(buffer.dwBufSize + 1024);

	// ItZbg
	if(dwOffset) ReadFromStdin(buffer.lpBuffer,dwOffset,dwDebugLevel);
	
	// dummy.dat 
	HANDLE hDummy;
	if(dwMakeDummyFromData) i = CREATE_ALWAYS; else i = CREATE_NEW;
	if((hDummy = CreateFile("dummy.dat",GENERIC_WRITE,
		0,NULL,i,FILE_ATTRIBUTE_NORMAL,NULL)) != INVALID_HANDLE_VALUE){

		if(dwMakeDummyFromData){
			i = ReadFromStdin((LPBYTE)szTemp,dwMakeDummyFromData,dwDebugLevel);
		}
		else{
			strcpy(szTemp,"dummy");
			i = strlen(szTemp);
		}
		
		WriteFile(hDummy,szTemp,i,&i2,NULL);
		CloseHandle(hDummy);
	}
	
	// wave format o
	if(bOutWaveFormat){
		WriteRecWaveHeader(buffer.lpBuffer,&waveFmt,MAXDWORD/2);
		buffer.dwBotPos = 44;
		buffer.dwBufTailAddr = 44;
	}

	
	//----------------------
	// C[v
	// qvZXI܂ ContinueDebugEvent 
	//----------------------

	dwShowWindow = 0;
	if(GetCurrentOutputMode() != ERRMODE_DIALOG){
		if(dwDebugLevel >=1 ) dwShowWindow |= DIAG_SHOWINFO;
		if(dwDebugLevel >=2 ) dwShowWindow |= DIAG_SHOWSTACK;
		if(dwDebugLevel >=3 ) dwShowWindow |= DIAG_SHOWSTACK2;
		if(dwDebugLevel >=4 ) dwShowWindow |= DIAG_SHOWREG | DIAG_SHOWCALLSTACK;
		if(dwDebugLevel >=5 ) dwShowWindow |= DIAG_SHOWCODE | DIAG_SHOWVARWATCH;
	}

	
	dwEventNum = 0;
	OutputErrorMessage("\nStart child process...\n--------------------------------------------\n\n");
	for(;;)
	{

L_TIMEOUT:

		// Cxg҂
		DWORD dwWaitTime;
		if(dwDebugLevel) dwWaitTime = 10000;
		else dwWaitTime = 100;

		if(!WaitForDebugEvent(&debugEvent,dwWaitTime))
		{
			DWORD dwExitCode;
			if(dwDebugLevel) OutputErrorMessage("\nDebug Event: timeout\n");

			GetExitCodeProcess(hProcess,&dwExitCode);
			if(dwExitCode != STILL_ACTIVE)
			{
				OutputErrorMessage("Child process is not active\n");
				goto L_ERROR;
			}
			else 
			{
				// qvZX̏xĂĂƂȂ̂
				// DxグĂ݂ (2003/1/14 ǉ)
				if(FeofStdin())
				{
					for(i=0;i<thTable.dwThreadNum;i++)
					{
						if(thTable.hThread[i])
						{
							SetThreadPriority(thTable.hThread[i],THREAD_PRIORITY_HIGHEST);
						}
					}
				}
			}

			goto L_TIMEOUT;
		}
#ifdef SHOW_ALL_DEBUG_EVENT
		else 
		{
			dwReportRet = ReportDebugEvent(hProcess,&debugEvent,dwDebugLevel);
			if(dwReportRet == REPORT_TERMINATE) goto L_ERROR;
		}
#endif
		
		dwContinueStatus = DBG_CONTINUE;

		switch(debugEvent.dwDebugEventCode)
		{
			// I
		case EXIT_PROCESS_DEBUG_EVENT: 

			SHOW_EVENTHEAD			
			if(dwDebugLevel) 
			{
				OutputErrorMessage("\n****************** EXIT_PROCESS ******************\n");
			}
			
			goto L_END;
			
			// DLL ̃[h
		case LOAD_DLL_DEBUG_EVENT:
			
			SHOW_EVENTHEAD			
			LoadDllEvent(hProcess,
				(DWORD)(debugEvent.u.LoadDll.lpBaseOfDll),
				dwDebugLevel);
			
			break;
			
			// Xbhꂽ
			// Xbhƃnh̃e[uXV
		case CREATE_THREAD_DEBUG_EVENT:
			
			SHOW_EVENTHEAD			
			if(dwDebugLevel) {
				OutputErrorMessage("\n****************** CREATE_THREAD ******************\n");
				OutputErrorMessage("thread ID = 0x%x\n",debugEvent.dwThreadId);
				OutputErrorMessage("thread handle = 0x%x\n",debugEvent.u.CreateThread.hThread);
			}
			
			i = thTable.dwThreadNum;
			thTable.dwThreadID[i] = debugEvent.dwThreadId;
			thTable.hThread[i] = debugEvent.u.CreateThread.hThread;
			thTable.dwThreadNum++;
			break;
			
		case EXIT_THREAD_DEBUG_EVENT:
			
			SHOW_EVENTHEAD			
			if(dwDebugLevel){
				OutputErrorMessage("\n****************** EXIT_THREAD ******************\n");
				OutputErrorMessage("thread ID = 0x%x\n",debugEvent.dwThreadId);
				OutputErrorMessage("exit code = 0x%x\n",debugEvent.u.ExitThread.dwExitCode);
			}
			
			for(i=0;i<thTable.dwThreadNum;i++){
				if(thTable.dwThreadID[i] == debugEvent.dwThreadId){
					thTable.dwThreadID[i] = 0;
					thTable.hThread[i] = NULL;
					break;
				}
			}
			
			break;
			
			// O
		case EXCEPTION_DEBUG_EVENT:
			
			// ݂̃XbhԍƃXbhnhEIP ̑擾
			dwCurThreadNum = 0;
			while(thTable.dwThreadID[dwCurThreadNum] != debugEvent.dwThreadId 
				&& dwCurThreadNum < MAX_OPENHANDLE) dwCurThreadNum++;
			if(dwCurThreadNum == MAX_OPENHANDLE){ 	
				OutputErrorMessage("\nError:  Could not get the thread number!\n");
				goto L_ERROR;
			}
			
			hCurThread = thTable.hThread[dwCurThreadNum];
			dwEIP = GetCurrentEIP(hCurThread);
			lpCurThInfo = &thInfo[dwCurThreadNum];
			
			switch(debugEvent.u.Exception.ExceptionRecord.ExceptionCode)
			{
				//-----------------------------
				// VOXebvs̏
				//-----------------------------
			case EXCEPTION_SINGLE_STEP:
				
				// lpThInfo->dwSingleStepAddr Ŏw肷AhX̃R[h
				// ۑĂu[Nł
				if(SortBreakIndex(lpCurThInfo->dwSingleStepAddr) != -1)
				{ 
					if(!EmbedBreak(hProcess,lpCurThInfo->dwSingleStepAddr))
					{
						OutputErrorMessage("fail to set break point.");
						goto L_ERROR;
					}
				}

				lpCurThInfo->dwSingleStepAddr = 0;

				// Xebvs[h
				if(bStepMode)
				{
					dwESP = ReadDebugStack(hProcess,hCurThread,(LPVOID)&lpCurThInfo->defaultParam,sizeof(DEFAULTFUNCPARAM));
					GetOperand(dwEIP,szOperand);
					if(!DialogMode(hProcess,hCurThread,lpCurThInfo,dwEIP,dwESP,szOperand,&diagData,&bStepMode)) goto L_ERROR;
					ExecStep(hProcess,hCurThread);
					lpCurThInfo->dwSingleStepAddr = dwEIP;
				}

				break;
	
				
				//------------------------------------------------------
				// u[N|Cg̏
				//------------------------------------------------------

			case EXCEPTION_BREAKPOINT:

				// R[hۑĂȂOs
				if(SortBreakIndex(dwEIP-1) == -1)
				{
					dwContinueStatus = DBG_EXCEPTION_NOT_HANDLED;  
					goto L_CONTINUEDEBUG;
				}

				// u[N|Cg̕ PC ߂ƂB
				dwEIP--;
				
				// JE^Abv
				dwHitCount = CountUpAddr(dwEIP,&dwObservNum);
				
				// IWiR[h(1 oCg)
				if(!RestoreBreakPoint(
					hProcess,
					hCurThread,
					dwEIP,
					&lpCurThInfo->dwSingleStepAddr,
					1
					)) 
				{
					OutputErrorMessage("RestoreBreakPoint : failed at EXCEPTION_BREAKPOINT\n");
					goto L_ERROR;
				}
				
				// u[ÑXLbv
				if(dwHitCount < dwObservNum || dwObservNum == 0){
					ExecStep(hProcess,hCurThread);
					break;
				}
				
				// X^bNǂݍ & X^bÑAhX擾
				if(!(dwESP = ReadDebugStack(hProcess,hCurThread,(LPVOID)&lpCurThInfo->defaultParam,sizeof(DEFAULTFUNCPARAM)))){
					OutputErrorMessage("Can't read stack data.\n");
					goto L_ERROR;
				}
				
				// Iyh擾
				if(GetCurrentOutputMode() == ERRMODE_DIALOG ||
					dwDebugLevel >=5){
					GetOperand(dwEIP,szOperand);
				}	

				SHOW_EVENTHEAD			
			
				//----------------------------------------
				// ȉAʂɊĎ֐̏
				//----------------------------------------
				
				//----------------------------------------
				// CreateFile
				//----------------------------------------
				if(dwEIP == dwAPIaddr[CODE_CREATEFILEW])
				{
					ShowInformation(hProcess,hCurThread,lpCurThInfo,dwEIP,dwESP,0,szOperand,dwShowWindow);
					if(!Event_CreateFile(hProcess,
						hCurThread,
						lpCurThInfo,
						((dwGetDefApiAddr != GETDEFAPIADDR_BYIMPORT) && (dwGetDefApiAddr != GETDEFAPIADDR_MMIO)),
						(dwGetDefApiAddr == GETDEFAPIADDR_MMIO),
						dwDebugLevel)) goto L_ERROR;
				}
				
				//----------------------------------------
				// CreateFile  2
				// CreateFile() 甲 eax 擾ꍇ
				//----------------------------------------
				else if(dwEIP == lpCurThInfo->dwOpenRetAddrW){
	
					if(!Event_CreateFile2(hProcess,
						hCurThread,
						lpCurThInfo,
						&fTable,
						&buffer,
						dwDebugLevel)) goto L_ERROR;	
				}
				
				
				//----------------------------------------
				// CloseHandle
				//----------------------------------------
				else if(dwEIP == dwAPIaddr[CODE_CLOSEHANDLE])
				{
					ShowInformation(hProcess,hCurThread,lpCurThInfo,dwEIP,dwESP,0,szOperand,dwShowWindow);
					if(!Event_CloseHandle(hProcess,
						hCurThread,
						lpCurThInfo,
						&fTable,
						dwDebugLevel)) goto L_ERROR;
				}
				
				//----------------------------------------
				// SetFilePointer
				//----------------------------------------
				else if(dwEIP == dwAPIaddr[CODE_SETFILEPOINTER])
				{
					ShowInformation(hProcess,hCurThread,lpCurThInfo,dwEIP,dwESP,0,szOperand,dwShowWindow);
					if(!Event_SetFilePointer(hProcess,
						hCurThread,
						lpCurThInfo,
						&fTable,
						&buffer,
						(dwGetDefApiAddr == GETDEFAPIADDR_MMIO),
						dwDebugLevel)) goto L_ERROR;	
				}
				
				//----------------------------------------
				// ReadFile
				//----------------------------------------
				else if(dwEIP == dwAPIaddr[CODE_READFILE])
				{
					
					ShowInformation(hProcess,hCurThread,lpCurThInfo,dwEIP,dwESP,0,szOperand,dwShowWindow);
					if(!Event_ReadFile(hProcess,
						hCurThread,
						lpCurThInfo,
						&fTable,
						&buffer,
						bVerbose,
						(dwGetDefApiAddr == GETDEFAPIADDR_MMIO),
						dwDebugLevel)) goto L_ERROR;			
				}

				
				//----------------------------------------
				// GetFileSize
				//----------------------------------------
				else if(dwEIP == dwAPIaddr[CODE_GETFILESIZE])
				{
					ShowInformation(hProcess,hCurThread,lpCurThInfo,dwEIP,dwESP,0,szOperand,dwShowWindow);
					if(!Event_GetFileSize(hProcess,
						hCurThread,
						lpCurThInfo,
						&fTable,
						&buffer,
						(dwGetDefApiAddr == GETDEFAPIADDR_MMIO),
						dwDebugLevel)) goto L_ERROR;	
				}

				// ̑̊֐(-breakfile Őݒ)
				else 
				{

					ShowInformation(hProcess,hCurThread,lpCurThInfo,dwEIP,dwESP,0,szOperand,dwShowWindow);
					// Xebvs
					ExecStep(hProcess,hCurThread);
				}
				
				// Θb[h
				if(GetCurrentOutputMode() == ERRMODE_DIALOG){
					if(!DialogMode(hProcess,hCurThread,lpCurThInfo,dwEIP,dwESP,szOperand,&diagData,&bStepMode)) goto L_ERROR;
				}

				break;
			
				//-------------------------
				// ̗̑O
				//-------------------------
		default: 
			dwReportRet = ReportDebugEvent(hProcess,&debugEvent,dwDebugLevel);
			if(dwReportRet == REPORT_TERMINATE) goto L_ERROR;
			
			if(dwReportRet == REPORT_NOTHANDLE)
			{
				// O̎͗O𑱍s 2003/1/16 ǉ
				// w肵Ȃ try-catch s
				dwContinueStatus = DBG_EXCEPTION_NOT_HANDLED;  
				goto L_CONTINUEDEBUG;
			}

			break;
			}

			break;
			
			default: 
				dwReportRet = ReportDebugEvent(hProcess,&debugEvent,dwDebugLevel);
				if(dwReportRet == REPORT_TERMINATE) goto L_ERROR;
				break;
		}

L_CONTINUEDEBUG:
		
		if(!ContinueDebugEvent(debugEvent.dwProcessId,debugEvent.dwThreadId,dwContinueStatus))
		{
			if(dwDebugLevel) OutputErrorMessage("ContinueDebugEvent failed : process = 0x%x thread = 0x%x",
			debugEvent.dwProcessId,debugEvent.dwThreadId);
		}
	}
	
L_END:
	dwRet = 0;
	
L_ERROR:

	if(bAdjustWaveSize)
	{
		OutputErrorMessage("\n\nAdjusting wave header...");
		if(AdjustWaveDataSize(szAdjustWaveSize)) OutputErrorMessage("done.\n");
	}
	
	if(dwDebugLevel)
	{
		OutputErrorMessage("\n\n************************************\n");
		ShowModuleName();
		ShowTotalBreakInfo();
	}
	
	if(GetCurrentOutputMode() == ERRMODE_DIALOG)
	{

		// ݒۑ
		SaveSettingFile(&diagData);

		// u[Nt@Cۑ
		SaveBreakSettingFile(szBreakFile,TRUE);
	}

	if(buffer.lpBuffer) free(buffer.lpBuffer);
	ClearBreakInfo();
	TraceClose(hProcess);
	CloseModuleInfo();

	if(dwRet)
		OutputErrorMessage("\n\nterminated.\n");
	else
		OutputErrorMessage("\n\ndone.\n");

	CloseOutputMode();	

	return dwRet;
}


//EOF