//  vZX֌W
//  Copyright (c) 2001-2003 Tomoya Tokairin
#include "common.h"
#include <winnt.h>
#include "debug.h"

//---------------------------------------------------
// vZXJn̂҂֐
BOOL WaitProcessStart(LPPROCESS_INFORMATION lpProInfo,
					  DEBUG_EVENT *lpDebugEvent,
					  LPDWORD lpdwImageBase,
					  LPDWORD lpdwStartAddr,
					  LPDWORD lpdwDllImageBase,
					  BOOL bDebug)
{
	DWORD i = 0;

	for(;;){
		ContinueDebugEvent(lpDebugEvent->dwProcessId,lpDebugEvent->dwThreadId,DBG_CONTINUE);
		WaitForDebugEvent(lpDebugEvent,INFINITE);
		
#ifdef SHOW_ALL_DEBUG_EVENT
		if(bDebug) ReportDebugEvent(lpDebugEvent);
#endif
		if(lpDebugEvent->dwDebugEventCode == CREATE_PROCESS_DEBUG_EVENT){
			*lpdwImageBase = (DWORD)(lpDebugEvent->u.CreateProcessInfo.lpBaseOfImage);
			*lpdwStartAddr = (DWORD)(lpDebugEvent->u.CreateProcessInfo.lpStartAddress);
		}
		
		if(lpDebugEvent->dwDebugEventCode == EXCEPTION_DEBUG_EVENT &&
			lpDebugEvent->u.Exception.ExceptionRecord.ExceptionCode == EXCEPTION_BREAKPOINT) 
			break;

		if(lpDebugEvent->dwDebugEventCode == LOAD_DLL_DEBUG_EVENT) 
			lpdwDllImageBase[i++] = (DWORD)(lpDebugEvent->u.LoadDll.lpBaseOfDll);
	}	
	
	return TRUE;
}


//--------------------------------
// exe t@C DLL ̃C|[ge[uЂ[猟
// API ̃AhX𒲂ׂ֐
// DOS J[l̃EBhEY̏ꍇAȖʓ|ȂƂȂƃAhX擾łȂc
BOOL SearchImportTableInAllDLL(LPDWORD dwAPIaddr,HANDLE hProcess,
							   DWORD dwImageBase,LPDWORD dwDllImageBase,
							   LPSTR szAPIname[],
							   BOOL bSearchOnlyMSVCRT,  // MSVCRT.dll ݂̂T
							   BOOL bDebug){
	
	IMAGE_OPTIONAL_HEADER32 coffHead;
	DWORD i,i2,i3;
	char szModuleName[CHR_BUF];
	
	// Ƃ肠W[̃C|[ge[u𑖍
	if(!GetCoffHead("",FALSE,szModuleName,hProcess,dwImageBase,&coffHead,bDebug)) return FALSE;
	for(i=0;i<NUMOFREPLACEAPI;i++){
		dwAPIaddr[i] = GetImpAddrOfAPI(hProcess,dwImageBase,&coffHead,szAPIname[i],bDebug);
	}
	
	// ׂĂ API ̃e[u܂
	// [h DLL ̃C|[ge[u̒Ђ[璲ׂ 
	for(i=0;i<MAX_LOADDLL;i++)
	{
		for(i2=0,i3=dwAPIaddr[0];i2<NUMOFREPLACEAPI;i2++) i3 *= dwAPIaddr[i2];
		if(i3)	break;  // ׂẴAhXI

		// ׂĂ DLL 𒲂ׂĂAhXȂI
		if(!dwDllImageBase[i])
		{
			for(i2=0;i2<NUMOFREPLACEAPI;i2++)
			{
				if(dwAPIaddr[i2] ==0)
					OutputErrorMessage("can't get addr of %s\n",szAPIname[i2]);
			}
			break;
		}

		// DLL  coff wb_擾
		if(!GetCoffHead("",FALSE,szModuleName,hProcess,dwDllImageBase[i],&coffHead,bDebug)) return FALSE;
		
		// bSearchOnlyMSVCRT = TRUE Ȃ MSVCRT.dll ȊO͒e
		if(!bSearchOnlyMSVCRT || _stricmp(szModuleName,"MSVCRT.dll") == 0)
		{

			// DLL ̃C|[ge[u𑖍
			for(i2=0;i2<NUMOFREPLACEAPI;i2++)
			{
				if(!dwAPIaddr[i2])
					dwAPIaddr[i2] = GetImpAddrOfAPI(hProcess,dwDllImageBase[i],&coffHead,szAPIname[i2],bDebug);		
			}
			
		}
	}
	
	return TRUE;
}


//------------------------------------------------
// qvZXN break łފ֐
BOOL ExecTergetProcess(LPVOID lpExecData)
{
	
	char* lpszCommand = ((LPEXECDATA)lpExecData)->lpszCommand;
	LPPROCESS_INFORMATION lpProInfo = &((LPEXECDATA)lpExecData)->proInfo;
	BOOL bHideWindow = ((LPEXECDATA)lpExecData)->bHideWindow;
	LPDWORD dwAPIaddr = ((LPEXECDATA)lpExecData)->dwAPIaddr;
	BOOL bShowImport = ((LPEXECDATA)lpExecData)->bShowImport;
	BOOL bShowExport = ((LPEXECDATA)lpExecData)->bShowExport;
	DWORD dwDebugLevel = ((LPEXECDATA)lpExecData)->dwDebugLevel;
	DWORD dwGetDefApiAddr = ((LPEXECDATA)lpExecData)->dwGetDefApiAddr;
	LPSTR lpszBreakFile = ((LPEXECDATA)lpExecData)->lpszBreakFile;
	BOOL bDialog = ((LPEXECDATA)lpExecData)->bDialog;
	BOOL bSearchOnlyMSVCRT = ((LPEXECDATA)lpExecData)->bSearchOnlyMSVCRT;
	BOOL bNewConsole = ((LPEXECDATA)lpExecData)->bNewConsole;
	BOOL bHideConsole = ((LPEXECDATA)lpExecData)->bHideConsole;

	DEBUG_EVENT debugEvent;
	IMAGE_OPTIONAL_HEADER32 coffHead;

	DWORD i,i2;
	char szModuleName[CHR_BUF];
	char szExeName[CHR_BUF];
	DWORD dwDllImageBase[MAX_LOADDLL];
	DWORD dwImageBase;

	memset(dwDllImageBase,0,sizeof(DWORD)*MAX_LOADDLL);
	
	i=0; 
	while(lpszCommand[i] != ' ' && lpszCommand[i] != '\0'){
		szExeName[i] = lpszCommand[i];
		i++;
	}
	szExeName[i] = '\0';
	if(!strstr(szExeName,".exe")) strcat(szExeName,".exe");
	
	//----------------------------------
	// vZXN
	STARTUPINFO startInfo;
	memset(&startInfo,0,sizeof(STARTUPINFO));
	startInfo.cb = sizeof(STARTUPINFO);
	if(bHideConsole)
	{
		startInfo.dwFlags = STARTF_USESHOWWINDOW;
		startInfo.wShowWindow = SW_HIDE;
	}
	if(bHideWindow)
	{
		startInfo.dwFlags = STARTF_USESHOWWINDOW;
		startInfo.wShowWindow = SW_HIDE;
	}
	if(CreateProcess(NULL,lpszCommand,NULL,NULL,FALSE,
		DEBUG_PROCESS 
		| CREATE_NEW_CONSOLE * (dwDebugLevel > 0 || bNewConsole),
		NULL,NULL,&startInfo,lpProInfo))
	{
		if(dwDebugLevel) OutputErrorMessage("CreateProcess: %s\n",lpszCommand);
		
		//----------------------------------
		//vZXJn܂ő҂
		WaitProcessStart(lpProInfo,&debugEvent,&dwImageBase,&i,dwDllImageBase,dwDebugLevel);
		if(dwDebugLevel) 
			OutputErrorMessage("\n****** process start ******\nimage base = 0x%x\nstart addr = 0x%x\n",dwImageBase,i);


		//----------------------------------
		// -import : IAT ɓo^Ă֐ stdout ɕ\ďI
		if(bShowImport){
			if(!GetCoffHead("",FALSE,szModuleName,lpProInfo->hProcess,dwImageBase,&coffHead,dwDebugLevel)) return FALSE;
			ShowImportFunctions(lpProInfo->hProcess,dwImageBase,&coffHead);
			return TRUE;
		}

		//----------------------------------
		// -export : e DLL ̃GNX|[ge[u̒̊֐ stdout ɕ\ďI
		if(bShowExport){
			for(i=0;i<MAX_LOADDLL;i++){
				if(dwDllImageBase[i]){
					if(!GetCoffHead("",FALSE,szModuleName,lpProInfo->hProcess,dwDllImageBase[i],&coffHead,dwDebugLevel)) return FALSE;
					ShowExportFunctionsStdout(lpProInfo->hProcess,dwDllImageBase[i],&coffHead);
				}
				else break;
			}
			return TRUE;
		}
		
		//-------------------------
		//W[f[^x[Xo^
		SetModuleInfo(lpProInfo->hProcess,dwImageBase,szExeName);
		for(i=0;i<MAX_LOADDLL;i++) if(dwDllImageBase[i]) SetModuleInfo(lpProInfo->hProcess,dwDllImageBase[i],NULL);else break;

		//----------------------------------
		// DLL \ & R[X^bNg[X̂߂̏
		if(dwDebugLevel >= 2 || bDialog){
			
			if(dwDebugLevel >= 2)
				OutputErrorMessage("\n\n[Information of DLLs]\n");
			
			// g[X
			if(dwDebugLevel >= 4 || bDialog){
				TraceInit(lpProInfo->hProcess);
				// vZXg̃V{e[u[h
				LoadSymbolTable(lpProInfo->hProcess,szExeName);				
			}
		
			for(i=0;i<MAX_LOADDLL;i++){
				if(dwDllImageBase[i]){
					if(!GetCoffHead("",FALSE,szModuleName,lpProInfo->hProcess,dwDllImageBase[i],&coffHead,(dwDebugLevel >= 2))) return FALSE;
					if(dwDebugLevel >= 4  || bDialog) LoadSymbolTable(lpProInfo->hProcess,szModuleName);				
				}
				else break;
			}
		}
		

		//-----------------------------
		// eAPI ̃AhX擾
		
		// API 
		char *szAPIname[NUMOFREPLACEAPI]=
		{
			"ReadFile",
				"SetFilePointer",
				"CreateFileW", 
				"CloseHandle",
				"GetFileSize"
		};
		
		// ftHg API ̃AhX
		DWORD dwDefaultAPIaddr[NUMOFREPLACEAPI] =
		{ 	
			(DWORD)ReadFile,
				(DWORD)SetFilePointer,
				(DWORD)CreateFileW, 
				(DWORD)CloseHandle,
				(DWORD)GetFileSize
		};

		// -dos
		if(dwGetDefApiAddr == GETDEFAPIADDR_BYIMPORT)
		{
			
			// DOS J[l̏ꍇ CreateFileW łȂ CreateFileA 
			// (CreateFileW ̃AhX擾łȂ̂)
			wsprintf(szAPIname[CODE_CREATEFILEW],"CreateFileA");

			// MSCVRT.dll ݂̂ŃT[`
			bSearchOnlyMSVCRT = TRUE;

			if(!SearchImportTableInAllDLL(dwAPIaddr,lpProInfo->hProcess,
				dwImageBase,dwDllImageBase,
				szAPIname,bSearchOnlyMSVCRT,
				(dwDebugLevel >= 2))) return FALSE;

		}

		// -mmio
		else if(dwGetDefApiAddr == GETDEFAPIADDR_MMIO)
		{ 
			// mmio nAPI Ƀ`FW
			wsprintf(szAPIname[CODE_CREATEFILEW],"mmioOpenA");
			wsprintf(szAPIname[CODE_SETFILEPOINTER],"mmioSeek");
			wsprintf(szAPIname[CODE_READFILE],"mmioRead");
			wsprintf(szAPIname[CODE_CLOSEHANDLE],"mmioClose");

			if(!SearchImportTableInAllDLL(dwAPIaddr,lpProInfo->hProcess,
				dwImageBase,dwDllImageBase,
				szAPIname,
				bSearchOnlyMSVCRT,
				(dwDebugLevel >= 2))) return FALSE;
		}

		// -stdin
		else if(dwGetDefApiAddr == GETDEFAPIADDR_BYEXPORT)
		{ 
			for(i=0;i<MAX_LOADDLL;i++)
			{
				if(dwDllImageBase[i])
				{
					if(!GetCoffHead("",FALSE,szModuleName,lpProInfo->hProcess,dwDllImageBase[i],&coffHead,FALSE)) return FALSE;

					// krenel32.dll ̃GNX|[ge[uAPĨAhX擾
					if(!_stricmp(szModuleName,"kernel32.dll"))
					{
						for(i2=0;i2<NUMOFREPLACEAPI;i2++)
						{
							dwAPIaddr[i2] = GetExpAddrOfAPI(lpProInfo->hProcess,dwDllImageBase[i],&coffHead,szAPIname[i2],(dwDebugLevel >= 2));
						}
						break;
					}
				}
				else
				{
					OutputErrorMessage("not found kernel32.dll\n");
					return FALSE;
				}
			}
		}

		// -defaultaddr
		else if(dwGetDefApiAddr == GETDEFAPIADDR_DEFAULT)
		{ 
			for(i=0;i<NUMOFREPLACEAPI;i++)  dwAPIaddr[i] = dwDefaultAPIaddr[i];
		}

		// -nostdin (ftHgݒ)
		else 
		{ 
			for(i=0;i<NUMOFREPLACEAPI;i++)  dwAPIaddr[i] = 0;
		}
		
		//-----------------------------
		// API break ł
		if(dwDebugLevel) OutputErrorMessage("\nset break point to:\n");
		
		for(i=0;i<NUMOFREPLACEAPI;i++)
		{
			if(dwAPIaddr[i])
			{
				if(dwDebugLevel) OutputErrorMessage("%s = %x\n",szAPIname[i],dwAPIaddr[i]);
				if(!PushBreakatSpecifiedAddr(lpProInfo->hProcess,dwAPIaddr[i],MAX_ORG_CODE,szAPIname[i],NULL,1)){
					dwAPIaddr[i] = 0;
				}
			}
		}

		//----------------------------
		// -breakfile Ŏw肵t@Cu[Nǂݍ
		if(strlen(lpszBreakFile))
		{
			ReadBreakSettingFile(lpProInfo->hProcess,lpszBreakFile,(dwDebugLevel>=2));
		}
		
		ContinueDebugEvent(debugEvent.dwProcessId,debugEvent.dwThreadId,DBG_CONTINUE);
	}
	else 
	{
		OutputErrorMessage("Can't CreateProcess: %s \n",lpszCommand);
		return FALSE;
	}
	
	return TRUE;
}

// EOF
