// vZ֌W
//
// Copyright (c) 2001-2002 Tomoya Tokairin


#include "dbg.h"


// eax Ƃ̎̒̕l̏o
DWORD GetNumberFromString(LPSTR lpszStr,LPCONTEXT lpContext){

	DWORD dwOut,i;
	char *endpointer;
	char *szReg[9] = {"eax","ebx","ecx","edx","esi","edi","eip","esp","ebp"};

	
	for(i=0;i<9;i++){
		if(stricmp(lpszStr,szReg[i]) == 0) goto L_REG;
	}

	// 16 i
	endpointer = lpszStr + strlen(lpszStr);
	dwOut = strtoul(lpszStr,&endpointer,16);
	
	return dwOut;
	
L_REG:
	
	switch(i){
	case 0: dwOut = lpContext->Eax; break;
	case 1: dwOut = lpContext->Ebx; break;
	case 2: dwOut = lpContext->Ecx; break;
	case 3: dwOut = lpContext->Edx; break;
	case 4: dwOut = lpContext->Esi; break;
	case 5: dwOut = lpContext->Edi; break;
	case 6: dwOut = lpContext->Eip; break;
	case 7: dwOut = lpContext->Esp; break;
	case 8: dwOut = lpContext->Ebp; break;
	}

	
	return dwOut;
}


// IyhvZ(C)
DWORD CalcOperandMain(LPSTR lpszForm,LPCONTEXT lpContext){

	DWORD dwOut,dwMulti,dwStrLen,i,dwEmbCount;
	char* lpCurPos;
	char c;
	char szTemp[CHR_BUF];

	dwStrLen = strlen(lpszForm);

	dwOut = 0;
	dwMulti = 1;
	
	for(lpCurPos = lpszForm + dwStrLen -1; lpCurPos >= lpszForm; lpCurPos--){
		c = lpCurPos[0];
		switch(c){

		case ')': // ( ) ̏ꍇ

			memset(szTemp,0,CHR_BUF);
			lpCurPos--;
			i = (DWORD)lpCurPos;
			dwEmbCount = 1;
			while(dwEmbCount && lpCurPos != lpszForm){
				c = (lpCurPos--)[0];
				if(c == ')') dwEmbCount++;
				if(c == '(') dwEmbCount--;
			}
			szTemp[0] = '+';
			memcpy(szTemp+1,lpCurPos+2,i - (DWORD)lpCurPos -1);
			c = lpCurPos[0];
			dwMulti *= CalcOperandMain(szTemp,lpContext);
			goto L_CALC;

		case '*':
		case '+':
		case '-':
			dwMulti *= GetNumberFromString(lpCurPos+1,lpContext);
L_CALC:
			lpCurPos[0] = '\0';
			if(c == '*') break;
			dwOut = (c == '+') ?  dwOut + dwMulti : dwOut - dwMulti;
			dwMulti = 1;
			
			break;
		}
	}

	return dwOut;
}


// dword ptr [] Ƃ [] ̊Ԃ̕𔲂o֐
void RemoveEmbrace(DWORD pos,LPSTR szForm){

	char szTemp[CHR_BUF],c;
	DWORD i=0;

	memset(szTemp,0,CHR_BUF);
	c = szForm[pos];
	for(;;){
		c = szForm[pos++];
		if(c == '\0' ||  c == ']') break;
		szTemp[i++] = c;
	}

	strcpy(szForm,szTemp);
}



// IyȟvZ
BOOL CalcOperand(HANDLE hThread,LPSTR lpszForm,LPDWORD lpdwOut){

	char szInput[CHR_BUF],c;
	DWORD i,pos;
	CONTEXT context;

	// 󔒂Ɖsl߂
	pos = 0;
	memset(szInput,0,CHR_BUF);
	szInput[pos++] = '+';
	for(i=0;i<CHR_BUF;i++){
		c = lpszForm[i];
		if(c == '\0') break;
		if(c != ' ' && c != '\r' && c != '\n') szInput[pos++] = c;
	}

	// [] ̊Ԃ̕𒊏o
	// szInput +1 ƂĂ̂͐擪 + ΂
	if(!strnicmp(szInput+1,"dwordptr",8)){
		RemoveEmbrace(9,szInput+1);  
	}
	else if(!strnicmp(szInput+1,"byteptr",7)){
		RemoveEmbrace(8,szInput+1);
	}
	else if(!strnicmp(szInput+1,"wordptr",7)){
		RemoveEmbrace(8,szInput+1);
	}

	// fs:  FALSE
	if(!strnicmp(szInput+1,"fs:",3)) return FALSE;  
	//dword ptr fs:[ ݂ȂƂ RemoveEmbrace()  dword ptr f ̂
	if(!strnicmp(szInput+1,"s:[",3)) return FALSE;  

	context.ContextFlags = CONTEXT_FULL;
	if(!GetThreadContext(hThread,&context)){
		OutputErrorMessage("Can't GetThreadContext\n");
		return FALSE;
	}

	*lpdwOut = CalcOperandMain(szInput,&context);

	return TRUE;
}


// Iyh擾
BOOL GetOperand(DWORD dwEIP,char szOperand[][CHR_BUF]){

	DWORD i,i2;
	char szTemp[CHR_BUF],szTemp2[CHR_BUF];
	char c;

	strcpy(szOperand[2],szOperand[0]);
	strcpy(szOperand[3],szOperand[1]);

	ShowAsmCode(dwEIP,1,szTemp);
	szTemp2[CHR_BUF-1] = '\0';
	i = strlen(szTemp);
	i2 = CHR_BUF-2;
	while(i != -1){
		c = szTemp[i--];
		if(c == ',') break;
		if(c == ' '){ // 󔒂 3 ȏ㑱 break;
			if(szTemp[i] == ' ' && szTemp[i-1] == ' ') break;
		}
		if(c != '\r' && c != '\n') szTemp2[i2--] = c;
	}
	if(c == ',') strcpy(szOperand[1],szTemp2+i2+1);
	else{
		strcpy(szOperand[0],szTemp2+i2+1);
		strcpy(szOperand[1],"");
		return TRUE;
	}

	szTemp2[i2+1] = '\0';
	while(i != -1){
		c = szTemp[i--];
		if(c == ' '){ // 󔒂 3 ȏ㑱 break;
			if(szTemp[i] == ' ' && szTemp[i-1] == ' ') break;
		}
		szTemp2[i2--] = c;
	}
	strcpy(szOperand[0],szTemp2+i2+1);

	return TRUE;
}

// EOF