// W[֌W̊֐
//
// Copyright (c) 2001-2002 Tomoya Tokairin

#include "dbg.h"

#define MAX_MODULE		512	// ő僂W[

typedef struct{
	DWORD dwAddr;
	DWORD pos;
}ASMFILEINFO,*LPASMFILEINFO;


// W[̃f[^x[X
// AhX烂W[擾̂Ɏg
typedef struct{
	CHAR szMudule[CHR_BUF];			// W[(gq)
	CHAR szModuleName[CHR_BUF];		// W[(gqȂ)
	DWORD dwImageBase;				// (*.asmɕ\ꂽ)C[Wx[X
	DWORD dwAddr;					// (ۂ)C[Wx[X
	DWORD dwSize;					// TCY
	DWORD dwNextIndex;				// ̃CfbNX
	FILE* fAsm;
	LPASMFILEINFO lpAsmIndex;
	DWORD dwMaxIndexLine;
}MODULEINFO,*LPMODULEINFO;


MODULEINFO ModuleInfo[MAX_MODULE];
DWORD DwModuleNum = 0;
DWORD DwTopModuleIndex = 0;


//---------------------------------------------


//-----------------------------------------
// W[̃Zbg
BOOL SetModuleInfo(HANDLE hProcess,DWORD dwAddr,LPSTR lpszModule){

	DWORD i,dwCurAddr,dwSize;
	char szModule[CHR_BUF];
	DWORD dwPreIndex,dwCurIndex;
	IMAGE_OPTIONAL_HEADER32 coffHead;

	dwPreIndex = dwCurIndex = DwTopModuleIndex;
	for(i=0;i<DwModuleNum;i++){
		dwCurAddr = ModuleInfo[dwCurIndex].dwAddr;
		if(dwCurAddr == dwAddr) return TRUE;
		if(dwCurAddr > dwAddr) break;
		dwPreIndex = dwCurIndex;
		dwCurIndex = ModuleInfo[dwCurIndex].dwNextIndex;
	}
	
	// 擾
	if(!GetCoffHead("",FALSE,szModule,hProcess,dwAddr,&coffHead,FALSE)) return FALSE;
	dwSize = coffHead.SizeOfImage;
	if(lpszModule) strcpy(szModule,lpszModule);
	
	// VKǉ
	strcpy(ModuleInfo[DwModuleNum].szMudule,szModule);
	i = 0; for(;;){
		char c;
		c = ModuleInfo[DwModuleNum].szMudule[i];
		if(c == '.' || c == '\0') break;
		ModuleInfo[DwModuleNum].szModuleName[i++] = c;
	}
	ModuleInfo[DwModuleNum].szModuleName[i] = '\0';
	ModuleInfo[DwModuleNum].dwAddr = dwAddr;
	ModuleInfo[DwModuleNum].dwSize = dwSize;
	ModuleInfo[DwModuleNum].lpAsmIndex = NULL;

	if(i==0){ // 擪
		ModuleInfo[DwModuleNum].dwNextIndex = DwTopModuleIndex;
		DwTopModuleIndex = DwModuleNum;
	}
	else{
		ModuleInfo[DwModuleNum].dwNextIndex = 	ModuleInfo[dwPreIndex].dwNextIndex;
		ModuleInfo[dwPreIndex].dwNextIndex = DwModuleNum;
	}
	DwModuleNum++;

	return TRUE;
}


//---------------------------
// [hW[̈ꗗ
void ShowModuleName(){

	DWORD i = DwTopModuleIndex,i2;

	for(i2 = 0; i2 < DwModuleNum; i2++){
		OutputErrorMessage("0x%08x -- 0x%08x %s\n",
			ModuleInfo[i].dwAddr,ModuleInfo[i].dwAddr+ModuleInfo[i].dwSize,ModuleInfo[i].szMudule);
		i = ModuleInfo[i].dwNextIndex;
	}

}



//---------------------------
// W[̌n
BOOL CloseModuleInfo(){
	DWORD i;

	for(i = 0; i < DwModuleNum; i++){
		if(ModuleInfo[i].fAsm) fclose(ModuleInfo[i].fAsm);
		if(ModuleInfo[i].lpAsmIndex) free(ModuleInfo[i].lpAsmIndex);
	}

	return TRUE;
}




//----------------------------
// AhX烂W[ԍ擾(s -1)
DWORD GetModuleNumByAddr(DWORD dwAddr){

	DWORD i = DwTopModuleIndex,i2;

	for(i2 = 0; i2 < DwModuleNum; i2++){
		if(ModuleInfo[i].dwAddr <= dwAddr
			&& ModuleInfo[i].dwAddr + ModuleInfo[i].dwSize >= dwAddr) return i;
		i = ModuleInfo[i].dwNextIndex;
	}

	return -1;
}


//----------------------------
// AhX烂W[擾
BOOL GetModuleNameByAddr(DWORD dwAddr,LPSTR lpszModule){

	DWORD i;

	if((i = GetModuleNumByAddr(dwAddr)) == -1) {
		strcpy(lpszModule,"");
		return FALSE;
	}
	strcpy(lpszModule,ModuleInfo[i].szMudule);

	return TRUE;
}



//------------------------------
// AZuR[h̍쐬(diswin.exe gp)
BOOL CreateAsmCode(DWORD dwModNum,LPSTR lpszAsmFile){

	DWORD i,i2;
	char szModule[MAX_PATH],szSystem[MAX_PATH],szCommand[CHR_BUF];
	char szTemp[CHR_BUF];
	FILE* f=NULL;

	wsprintf(szModule,"%s",ModuleInfo[dwModNum].szMudule);
	if(fopen(szModule,"r") == NULL){
		GetSystemDirectory(szSystem,MAX_PATH);
		wsprintf(szModule,"%s\\%s",szSystem,ModuleInfo[dwModNum].szMudule);
		if(fopen(szModule,"r") == NULL){
			OutputErrorMessage("not found %s\n",ModuleInfo[dwModNum].szMudule);
		}
	}
	if(f) fclose(f);

	//----------------------------------
	// vZXN
	PROCESS_INFORMATION proInfo;
	STARTUPINFO startInfo;
	memset(&startInfo,0,sizeof(STARTUPINFO));
	startInfo.cb = sizeof(STARTUPINFO);

	wsprintf(szCommand,"diswin -s%s %s",ModuleInfo[dwModNum].szModuleName,szModule);
	OutputErrorMessage("exec: %s\n",szCommand);
	if(!CreateProcess(NULL,szCommand,NULL,NULL,FALSE,
		0,NULL,NULL,&startInfo,&proInfo)){
		OutputErrorMessage("not found diswin\n");
		return FALSE;
	}

	WaitForSingleObject(proInfo.hProcess,INFINITE);

	// .text  CODE ZNV܂łt@C
	for(i=1;i<20;i++){
		wsprintf(lpszAsmFile,"%s%02d.asm",ModuleInfo[dwModNum].szModuleName,i);
		if((f = fopen(lpszAsmFile,"r")) == NULL) return FALSE;
		for(i2=0;i2<7;i2++) fgets(szTemp,CHR_BUF,f);
		fclose(f);
		if(strstr(szTemp,".text")) break;
		if(strstr(szTemp,"CODE")) break;
	}

	return TRUE;
}


//------------------------------
// CfbNXt@C̍쐬
BOOL CreateAsmIndex(DWORD dwModNum){

	char szAsmFile[MAX_PATH],szIndexFile[MAX_PATH];
	DWORD dwLineNum,dwImageBage,i;
	char szLine[CHR_BUF],szAddr[10],*endpointer;
	FILE *fAsm = NULL,*fIndex = NULL;
	ASMFILEINFO asmInfo;
	fpos_t pos;
	
	wsprintf(szIndexFile,"%s.idx",ModuleInfo[dwModNum].szModuleName);

	// tAZu
	if(!CreateAsmCode(dwModNum,szAsmFile)) return FALSE;

	OutputErrorMessage("\ncreating index file: %s\n",szIndexFile);
	if((fAsm = fopen(szAsmFile,"r"))==NULL)
	{
		OutputErrorMessage("can't open %s\n",szAsmFile);
		return FALSE;
	}
	if((fIndex = fopen(szIndexFile,"wb"))==NULL)
	{
		OutputErrorMessage("can't open %s\n",szIndexFile);
		fclose(fAsm);
		return FALSE;
	}


	fseek(fIndex,0,SEEK_SET);
	fwrite(szAsmFile,1,MAX_PATH,fIndex); // t@Co

	// C[Wx[Xo
	fseek(fAsm,0,SEEK_SET);
	for(i=0;i<5;i++) if(!fgets(szLine,CHR_BUF,fAsm)) return FALSE;
	sscanf(szLine+17,"%x",&dwImageBage);
	fwrite(&dwImageBage,1,sizeof(DWORD),fIndex);

	// sf[^o
	fwrite(&dwLineNum,1,sizeof(DWORD),fIndex); // s()o
	fseek(fAsm,0,SEEK_SET);
	dwLineNum = 0;
	szAddr[8] = '\0';
	endpointer = szAddr+8;
	for(;;)
	{
		// AhXƃ|C^擾ďo
		if(fgetpos(fAsm,&pos)) break;
		if(!fgets(szLine,CHR_BUF,fAsm)) break;
		memcpy(szAddr,szLine,8);
		asmInfo.dwAddr = strtoul(szAddr,&endpointer,16);
		asmInfo.pos = (DWORD)pos;
		fwrite(&asmInfo,1,sizeof(ASMFILEINFO),fIndex);
		dwLineNum++;
	}

	// so
	fseek(fIndex,(MAX_PATH+sizeof(DWORD)),SEEK_SET);
	fwrite(&dwLineNum,1,sizeof(DWORD),fIndex);

	if(fAsm) fclose(fAsm);
	if(fIndex) fclose(fIndex);

	return TRUE;
}


//-----------------------------
// w肵AhX̃AZuR[h\
BOOL ShowAsmCode(DWORD dwAddr,
				 DWORD dwAdmLine, // AZuR[h̕\s
				 LPSTR lpszCode // NULL ŖȂ猻݂̃AhX̃R[hă^[(\)
				 ){

	DWORD dwModNum,i,i2,i3,i4;
	char szAsmFile[MAX_PATH],szIndexFile[MAX_PATH];
	char szLine[CHR_BUF];
	FILE *fAsm = NULL,*fIndex = NULL;
	ASMFILEINFO *lpAsmInfo,*lpCurAsmInfo;
	fpos_t pos;

	dwModNum = GetModuleNumByAddr(dwAddr);
	if(dwModNum == -1) return FALSE;

	dwAdmLine = (dwAdmLine/2)*2;

	// AZut@CJ
	if(ModuleInfo[dwModNum].lpAsmIndex == NULL)
	{
		// CfbNXt@C̃I[v
		wsprintf(szIndexFile,"%s.idx",ModuleInfo[dwModNum].szModuleName);
		if((fIndex = fopen(szIndexFile,"rb"))==NULL)
		{
			// CfbNXt@C쐬 & tAZu
			if(!CreateAsmIndex(dwModNum)) return FALSE;
			if((fIndex = fopen(szIndexFile,"rb"))==NULL){
				OutputErrorMessage("can't open %s\n",szIndexFile);
				return FALSE;
			}
		}

		// AZuR[ht@C̃I[v
		fread(szAsmFile,1,MAX_PATH,fIndex); // AZut@C擾
		if((ModuleInfo[dwModNum].fAsm = fopen(szAsmFile,"r"))==NULL)
		{
			OutputErrorMessage("can't open %s\n",szAsmFile);
			OutputErrorMessage("Please delete \"%s\" ,and push c again.\n",szIndexFile);
			fclose(fIndex);
			return FALSE;
		}
		// C[Wx[X擾
		fread(&(ModuleInfo[dwModNum].dwImageBase),1,sizeof(DWORD),fIndex);

		// CfbNXf[^ǂݍ
		fread(&i,1,sizeof(DWORD),fIndex); // s擾
		ModuleInfo[dwModNum].lpAsmIndex = (LPASMFILEINFO)malloc(sizeof(ASMFILEINFO)*i + 1024);
		fread(ModuleInfo[dwModNum].lpAsmIndex,1,sizeof(ASMFILEINFO)*i,fIndex);
		ModuleInfo[dwModNum].dwMaxIndexLine = i;
	}

	lpAsmInfo = ModuleInfo[dwModNum].lpAsmIndex;
	fAsm = ModuleInfo[dwModNum].fAsm;

	dwAddr = dwAddr - (ModuleInfo[dwModNum].dwAddr - ModuleInfo[dwModNum].dwImageBase);

	//  CfbNXf[^T[`ĕ\
	for(i=0;i<ModuleInfo[dwModNum].dwMaxIndexLine ;i++)
	{
		lpCurAsmInfo = lpAsmInfo+i;
		if(lpCurAsmInfo->dwAddr == dwAddr)
		{
			// ݂̃R[h lpszCode ɓă^[
			if(lpszCode)
			{
				pos = lpCurAsmInfo->pos;
				fsetpos(fAsm,&pos);
				fgets(lpszCode,CHR_BUF,fAsm);
				return TRUE;
			}

			// dwAdmLine/2 ߂
			i2 = i > dwAdmLine/2 ? i - dwAdmLine/2 : 0;
			i3 = i+dwAdmLine/2 < ModuleInfo[dwModNum].dwMaxIndexLine 
				? i+dwAdmLine/2 :ModuleInfo[dwModNum].dwMaxIndexLine;

			for(i4=i2;i4<i3;i4++)
			{
				lpCurAsmInfo = lpAsmInfo+i4;
				pos = (fpos_t)lpCurAsmInfo->pos;
				fsetpos(fAsm,&pos);
				fgets(szLine,CHR_BUF,fAsm);
				if(lpCurAsmInfo->dwAddr == dwAddr) OutputErrorMessage("->");
				else OutputErrorMessage("  ");
				OutputErrorMessage("%s",szLine);
			}

			break;
		}

	}

	if(fIndex) fclose(fIndex);
	return TRUE;
}

//EOF