// R[X^bÑg[X֌W
//
// Copyright (c) 2001-2002 Tomoya Tokairin

#include "dbg.h"

PIMAGEHLP_SYMBOL pImgSym = NULL;

//-----------------------------------
// 
BOOL TraceInit(HANDLE hProcess){

	DWORD i;

	i = sizeof(PIMAGEHLP_SYMBOL) -1 + CHR_BUF;
	pImgSym = (PIMAGEHLP_SYMBOL)malloc(i);
	memset(pImgSym,0,i);
	pImgSym->SizeOfStruct = i;
	pImgSym->MaxNameLength = CHR_BUF;

	// SymInitialize(hProcess,NULL,TRUE); łƂ܂
	// nOAbv̂ŁAfInvadeProcess  = FALSE Ƃ
	// ^ʖڂ SymLoadModule ŃV{e[u[h邱ƁB
	return SymInitialize(hProcess,NULL,FALSE);
}


//------------------------------------------
// V{e[ũ[h
BOOL LoadSymbolTable(HANDLE hProcess,LPSTR lpszModuleName){
	return SymLoadModule(hProcess,NULL,lpszModuleName,NULL,0,0);				
}


//------------------------------------------------
// I
BOOL TraceClose(HANDLE hProcess){

	if(pImgSym == NULL) return TRUE;

	free(pImgSym);
	return SymCleanup(hProcess);

}


//-------------------------------------------
// R[X^bNg[X֐
BOOL TraceStackFrame(HANDLE hProcess,
					 HANDLE hThread,
					 DWORD dwSize
					 ){

	STACKFRAME stackFrame;
	IMAGEHLP_MODULE moduleInfo;
	DWORD dwDispl;
	CONTEXT context;
	DWORD i;

	memset(&moduleInfo,0,sizeof(IMAGEHLP_MODULE));
	moduleInfo.SizeOfStruct = sizeof(IMAGEHLP_MODULE);

	context.ContextFlags = CONTEXT_FULL;
	if(!GetThreadContext(hThread,&context)){
		OutputErrorMessage("Can't GetThreadContext\n");
		return FALSE;
	}

	memset(&stackFrame,0,sizeof(STACKFRAME));
	stackFrame.AddrPC.Offset = context.Eip;
	stackFrame.AddrPC.Mode = AddrModeFlat;
	stackFrame.AddrFrame.Offset = context.Ebp;
	stackFrame.AddrFrame.Mode = AddrModeFlat;
	stackFrame.AddrStack.Offset = context.Esp;
	stackFrame.AddrStack.Mode = AddrModeFlat;

	for(i=0;i<dwSize;i++){

		if(!StackWalk(
			IMAGE_FILE_MACHINE_I386,
			hProcess,hThread,
			&stackFrame,
			NULL,NULL,
			SymFunctionTableAccess,
			SymGetModuleBase,NULL)) break;
		if(!stackFrame.AddrFrame.Offset) break;

		if(!SymGetModuleInfo(hProcess,stackFrame.AddrPC.Offset,&moduleInfo))
			strcpy(moduleInfo.ModuleName,"");
		if(!SymGetSymFromAddr(hProcess,stackFrame.AddrPC.Offset,&dwDispl,pImgSym))
			strcpy(pImgSym->Name,"");

		OutputErrorMessage("0x%08x %s : %s + 0x%x\n",
			stackFrame.AddrPC.Offset,
			moduleInfo.ModuleName,pImgSym->Name,dwDispl);

	}

	return TRUE;
}


//EOF