// ̑̊֐
// Copyright (c) 2001-2003 Tomoya Tokairin

#include<windows.h>
#include<stdio.h>
#include "common.h"
#include "debug.h"
#include "io.h"

#define SETTINGFILE "fstdin.dat"  // ݒt@C

//-----------------------------------------------

//-------------------------------------------------------------------
// R}hCɓnZbg֐
void SetCommandStrings(BOOL bCommand,
					   LPSTR lpszCommand,
					   LPSTR lpszStrings,
					   LPSTR lpszFile
					   )
{
	char szOut[MAX_COMMANDLEN];
	char fPath[MAX_PATH],fDrive[MAX_PATH],fName[MAX_PATH],fExt[MAX_PATH];
	int i,i2,i3;

	if(bCommand && strlen(lpszStrings))
	{
		_splitpath(lpszFile,fDrive,fPath,fName,fExt);
		i=0;i2=0;

		// Rs[
		while(lpszStrings[i]!='\0' && i2<MAX_COMMANDLEN)
		{
			//u
			if(lpszStrings[i]=='%')
			{
				switch(lpszStrings[i+1])
				{
					// %
				case '%':

					szOut[i2] = '%';
					i2++;
					i+=2;

					break;


					// "
				case '^':

					szOut[i2] = '"';
					i2++;
					i+=2;

					break;


					// hCu
				case 'd':

					i3 = 0;
					while(fDrive[i3]!='\0' && i2<MAX_COMMANDLEN)
					{
						szOut[i2] = fDrive[i3];
						i2++;i3++;
					}
					i+=2;

					break;

					// pX
				case 'p':

					i3 = 0;
					while(fPath[i3]!='\0' && i2<MAX_COMMANDLEN)
					{
						szOut[i2] = fPath[i3];
						i2++;i3++;
					}
					i+=2;

					break;


					// t@C
				case 'f':

					i3 = 0;
					while(fName[i3]!='\0' && i2<MAX_COMMANDLEN)
					{
						szOut[i2] = fName[i3];
						i2++;i3++;
					}
					i+=2;

					break;
					
					// gq
				case 'e':

					i3 = 0;
					while(fExt[i3]!='\0' && i2<MAX_COMMANDLEN)
					{
						szOut[i2] = fExt[i3];
						i2++;i3++;
					}
					i+=2;

					break;
	
				default:
					szOut[i2] = lpszStrings[i];
					i++;i2++;
				}
			}
			else 
			{
				szOut[i2] = lpszStrings[i];
				i++;i2++;
			}
		}

		szOut[i2] = '\0';
	}
	else wsprintf(szOut,"");

	strcpy(lpszCommand,szOut);
}





//-------------------------------------------------------------------
// _CAO[hݒǂݍ
BOOL ReadSettingFile(LPDIAGDATA lpDiagData){

	FILE* f;
	
	if((f=fopen(SETTINGFILE,"rb"))==NULL){
		lpDiagData->dwShowWindow = DIAG_SHOWINFO| DIAG_SHOWSTACK| DIAG_SHOWMEM|DIAG_SHOWCODE| DIAG_SHOWCALLSTACK| DIAG_SHOWREG| DIAG_SHOWVARWATCH;
		lpDiagData->dwDumpAddr = 0;
		return FALSE;
	}

	fread(lpDiagData,1,sizeof(DIAGDATA),f);
	fclose(f);
	return TRUE;
}


//-------------------------------------------------------------------
// _CAO[hݒ菑
BOOL SaveSettingFile(LPDIAGDATA lpDiagData){

	FILE* f;
	
	if((f=fopen(SETTINGFILE,"wb"))==NULL){
		return FALSE;
	}

	fwrite(lpDiagData,1,sizeof(DIAGDATA),f);
	fclose(f);
	return TRUE;
}



// EOF

