// wave ֌W̊֐
// Copyright (c) 2001-2002 Tomoya Tokairin
#include <windows.h>
#define CHR_BUF	256

int OutputErrorMessage(LPSTR lpszFormat, ...);
void MyMessageBox(HWND hWnd, LPSTR lpstr,LPSTR lpstr2,DWORD a){
	OutputErrorMessage(lpstr);
};


//-------------------------------------------------------------------
// WAVEtH[}bgZbg֐
VOID SetWaveFmt(LPWAVEFORMATEX lpWaveFmt,WORD waveChn,
				DWORD waveRate,	WORD waveBit)
{
	// tH[}bg̃`FbN
	if(waveRate != 11025 && waveRate != 22050  && waveRate != 32000
		&& waveRate != 44100 && waveRate != 48000) waveRate = 22050;
	
	if(waveChn != 1 && waveChn != 2) waveChn = 2;
	
	if(waveBit != 8 && waveBit != 16) waveBit = 16;

	lpWaveFmt->wFormatTag = (WORD)0x0001; // PCM tH[}bg
	lpWaveFmt->nChannels = waveChn;  // `l
	lpWaveFmt->nSamplesPerSec = waveRate; // [g
	lpWaveFmt->nAvgBytesPerSec = (DWORD)(waveRate*waveChn*waveBit/8); // byte/sec
	lpWaveFmt->nBlockAlign = (WORD)(waveChn*waveBit/8); // byte/block
	lpWaveFmt->wBitsPerSample = waveBit; // rbg
	lpWaveFmt->cbSize = (WORD)0; // g񖳂 
}




//-------------------------------------------------------------------
// WAVE wb_obt@ɃZbg֐
VOID WriteRecWaveHeader(LPBYTE buffer,LPWAVEFORMATEX lpWaveFmt,DWORD waveDataSize)
{
	
	DWORD dwPos;
	DWORD dwFoo;

	// RIFF (20 byte)
	dwPos = 0;
	memcpy(buffer+dwPos,"RIFF",4);
	dwPos += 4;
	dwFoo = (waveDataSize + 44) - 8;
	memcpy(buffer+dwPos,&dwFoo,sizeof(DWORD));
	dwPos += sizeof(DWORD);
	memcpy(buffer+dwPos,"WAVE",4);
	dwPos += 4;
	memcpy(buffer+dwPos,"fmt ",4);
	dwPos += 4;
	dwFoo = 16;
	memcpy(buffer+dwPos,&dwFoo,sizeof(DWORD));
	
	// format (16 byte)
	dwPos += sizeof(DWORD);
	memcpy(buffer+dwPos,lpWaveFmt,sizeof(WAVEFORMATEX)-sizeof(WORD));

	// data `N (8 byte)
	dwPos += sizeof(WAVEFORMATEX)-sizeof(WORD);
	memcpy(buffer+dwPos,"data",4);
	dwPos += 4;
	dwFoo = waveDataSize;
	memcpy(buffer+dwPos,&dwFoo,sizeof(DWORD));
}





//-------------------------------------------------------------------
// WAVE t@C̃tH[}bg≉tԂZbg֐
//
// mmio ĝ߂ĎOŃtH[}bg`FbNo[W

#define MAX_SEARCH 140  // `ÑT[`̍őoCg

BOOL GetWaveFormat(HWND hWnd,LPSTR lpszFileName
				   ,LPWAVEFORMATEX lpWaveFmt, // tH[}bg
				   LPDWORD lpdwWaveDataSize, // f[^TCY
				   LPDWORD lpdwWaveOffset, // f[^܂ł̃ItZbg
				   LPDWORD lpdwWaveTime, // t(~b)
				   BOOL bShowMsg )// G[bZ[W\邩ǂ
{
	
	HANDLE hdFile;
	DWORD dwPoint,dwWavePoint,dwByte,dwCkSize,dwFileSize;
	BYTE byteRead;
	CHAR szCheck[5];
	LARGE_INTEGER LI; // SetFilePointer p 
	CHAR szStr[CHR_BUF];
	
	
	// wb_̓X^[g
	
	// t@CI[v
	if((hdFile = CreateFile(lpszFileName,GENERIC_READ, 
		0, 0, OPEN_EXISTING, FILE_ATTRIBUTE_READONLY, NULL))==INVALID_HANDLE_VALUE){
		if(bShowMsg) MyMessageBox(hWnd, "t@CJ܂B", 
			"Error", MB_OK|MB_SETFOREGROUND|MB_ICONERROR);	
		return FALSE;
	}
	
	//RIFF t@C`FbN
	szCheck[4]='\0';
	LI.QuadPart = 0;
	SetFilePointer(hdFile,LI.LowPart, &LI.HighPart,FILE_BEGIN);
	ReadFile(hdFile,szCheck,4,&dwByte,NULL);
	if(strcmp(szCheck,"RIFF")!=0){
		CloseHandle(hdFile);
		if(bShowMsg) MyMessageBox(hWnd, "ʎq(RIFF)܂BWAVE t@Cł͂܂B",
			"Error", MB_OK|MB_SETFOREGROUND|MB_ICONERROR);	
		return FALSE;
	}
	
	// t@CTCỸ`FbN
	ReadFile(hdFile,&dwCkSize,sizeof(DWORD),&dwByte,NULL);
	dwFileSize = GetFileSize(hdFile,NULL);
	
	// WAVE `N邩Tă`FbN
	szCheck[3]='\0';
	for(dwPoint = 0;dwPoint<MAX_SEARCH;dwPoint++){
		LI.QuadPart = dwPoint;
		SetFilePointer(hdFile,LI.LowPart, &LI.HighPart,FILE_BEGIN);
		ReadFile(hdFile,&byteRead,1,&dwByte,NULL);
		if(byteRead == 'W'){
			ReadFile(hdFile,szCheck,3,&dwByte,NULL);
			if(strcmp(szCheck,"AVE")==0) break;
		}
	}
	
	if(dwPoint == MAX_SEARCH){
		CloseHandle(hdFile);
		if(bShowMsg) MyMessageBox(hWnd, "WAVE `N܂BWAVE tH[}bgł͂܂B",
			"Error", MB_OK|MB_SETFOREGROUND|MB_ICONERROR);	
		return FALSE;
	}
	
	dwWavePoint = dwPoint;
	
	// fmt `NT[`
	szCheck[3]='\0';
	for(dwPoint = dwWavePoint;dwPoint<MAX_SEARCH;dwPoint++){
		LI.QuadPart = dwPoint;
		SetFilePointer(hdFile,LI.LowPart, &LI.HighPart,FILE_BEGIN);
		ReadFile(hdFile,&byteRead,1,&dwByte,NULL);
		if(byteRead == 'f'){
			ReadFile(hdFile,szCheck,3,&dwByte,NULL);
			if(strcmp(szCheck,"mt ")==0) break;
		}
	}
	
	if(dwPoint == MAX_SEARCH){
		CloseHandle(hdFile);
		if(bShowMsg) MyMessageBox(hWnd, "tH[}bg`N܂Bf[^Ă܂B",
			"Error", MB_OK|MB_SETFOREGROUND|MB_ICONERROR);	
		return FALSE;
	}
	
	
	// `NTCYƃtH[}bg擾
	ReadFile(hdFile,&dwCkSize,sizeof(DWORD),&dwByte,NULL);
	ReadFile(hdFile,lpWaveFmt,sizeof(WAVEFORMATEX),&dwByte,NULL);
	
	if(sizeof(WAVEFORMATEX) != dwByte){
		CloseHandle(hdFile);
		if(bShowMsg) MyMessageBox(hWnd, "tH[}bg擾ł܂Bt@CĂ܂B",
			"Error", MB_OK|MB_SETFOREGROUND|MB_ICONERROR);	
		return FALSE;
	}
	
	// PCM ̏ꍇ cbSize o[ 0 ɂ
	lpWaveFmt->cbSize = 0; 
	
	
	// tH[}bg`FbN
	if(lpWaveFmt->wFormatTag != WAVE_FORMAT_PCM){		 
		CloseHandle(hdFile);
		if(bShowMsg) MyMessageBox(hWnd, "̌`̃tH[}bgɂ͑ΉĂ܂B",
			"Error", MB_OK|MB_SETFOREGROUND|MB_ICONERROR);	
		return FALSE;
	}
	
	// f[^`FbN
	DWORD waveRate,avgByte;	
	WORD waveChn,waveBit;	
	
	waveChn = lpWaveFmt->nChannels;  // `l
	waveRate = lpWaveFmt->nSamplesPerSec; // [g
	waveBit = lpWaveFmt->wBitsPerSample; // rbg
	avgByte = lpWaveFmt->nAvgBytesPerSec; //oCg/b
	
	if( waveRate != 8000 && waveRate != 11025 && waveRate != 22050 && waveRate != 32000 
		&& waveRate != 44100 && waveRate != 48000 ){
		CloseHandle(hdFile);
		if(bShowMsg){
			wsprintf(szStr,"w肳ꂽTvOg(%d hz)ɂ͑ΉĂ܂B",waveRate);
			MyMessageBox(hWnd,szStr,"Error", MB_OK|MB_SETFOREGROUND|MB_ICONERROR);
		}
		
		return FALSE;
	}
	
	if((waveChn != 1 && waveChn != 2) || 
		(waveBit != 8 && waveBit != 16)){
		CloseHandle(hdFile);
		if(bShowMsg) {
			wsprintf(szStr,"w肳ꂽtH[}bg(%d channel,%d bit)ɂ͑ΉĂ܂B",waveChn,waveBit);
			MyMessageBox(hWnd,szStr,"Error", MB_OK|MB_SETFOREGROUND|MB_ICONERROR);
		}
		return FALSE;
	}
	
	if(avgByte != waveChn*waveRate*waveBit/8){
		CloseHandle(hdFile);
		if(bShowMsg) {
			wsprintf(szStr,"tH[}bgُłBf[^j󂳂Ă\܂B");
			MyMessageBox(hWnd,szStr,"Error", MB_OK|MB_SETFOREGROUND|MB_ICONERROR);
		}
		return FALSE;
	}
	
	
	// data `NT[`
	szCheck[3]='\0';
	for(dwPoint = dwWavePoint;dwPoint<MAX_SEARCH;dwPoint++){
		LI.QuadPart = dwPoint;
		SetFilePointer(hdFile,LI.LowPart, &LI.HighPart,FILE_BEGIN);
		ReadFile(hdFile,&byteRead,1,&dwByte,NULL);
		if(byteRead == 'd'){
			ReadFile(hdFile,szCheck,3,&dwByte,NULL);
			if(strcmp(szCheck,"ata")==0) break;
		}
	}
	
	if(dwPoint == MAX_SEARCH){
		CloseHandle(hdFile);
		if(bShowMsg) MyMessageBox(hWnd, "Wave f[^܂Bf[^j󂳂Ă܂B",
			"Error", MB_OK|MB_SETFOREGROUND|MB_ICONERROR);	
		return FALSE;
	}
	
	// f[^TCY擾
	ReadFile(hdFile,&dwCkSize,sizeof(DWORD),&dwByte,NULL);
	if(lpdwWaveDataSize!=NULL) *lpdwWaveDataSize = dwCkSize;
	
	// ItZbg擾
	if(lpdwWaveOffset!=NULL) *lpdwWaveOffset = dwPoint+8;
	
	// wb_͏I
	CloseHandle(hdFile);
	
	// WAVE ̉tԌvZ(~b)
	if(lpdwWaveTime!=NULL) *lpdwWaveTime = (DWORD)((double)(*lpdwWaveDataSize)/(double)lpWaveFmt->nAvgBytesPerSec*1000);
	
	return TRUE;
}
#undef MAX_SEARCH


//-------------------------------------
// wave t@C̎TCYƃwb_킹֐
BOOL AdjustWaveDataSize(LPSTR lpszAdjFile){

	WAVEFORMATEX waveFmt;
	DWORD dwWaveOffset;
	DWORD dwFileSize;
	HANDLE hFile;
	DWORD dwFoo,dwByte;

	if(!GetWaveFormat(NULL,lpszAdjFile,&waveFmt,NULL,
				   &dwWaveOffset, 
				   NULL,FALSE)){
		OutputErrorMessage("Can't open the file %s\n",lpszAdjFile);
		return FALSE;
	}
	
	hFile = CreateFile(lpszAdjFile,GENERIC_READ|GENERIC_WRITE, 0, 0,
		OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);
	
	if(hFile == INVALID_HANDLE_VALUE){
		OutputErrorMessage("Can't open the file %s\n",lpszAdjFile);
		return FALSE;
	}
	
	dwFileSize = GetFileSize(hFile,NULL);

	SetFilePointer(hFile,4,NULL,FILE_BEGIN);
	dwFoo = dwFileSize - 8;
	WriteFile(hFile,&dwFoo,sizeof(DWORD),&dwByte,NULL);

	SetFilePointer(hFile,dwWaveOffset - 4,NULL,FILE_BEGIN);
	dwFoo = dwFileSize - dwWaveOffset;
	WriteFile(hFile,&dwFoo,sizeof(DWORD),&dwByte,NULL);

	CloseHandle(hFile);

	return TRUE;
}


//EOF